libmongoc 2.4.0
===============

## Notes

* Raise required version of libmongocrypt from 1.15.1 to 1.20.0 to support In-Use Encryption (corresponds to the CMake option: `ENABLE_CLIENT_SIDE_ENCRYPTION`).
* In a future minor release the minimum supported MongoDB Server version will be raised from 4.2 to 4.4. This is in accordance with [MongoDB Software Lifecycle Schedules](https://www.mongodb.com/legal/support-policy/lifecycles).

## Deprecations

* The Queryable Encryption "Text" APIs are deprecated for "String" APIs
  * `mongoc_client_encryption_encrypt_text_*` is deprecated for `mongoc_client_encryption_encrypt_string_*` to match the generally available "String" algorithm.
  * The `TextPreview` algorithm is deprecated. Use `String` instead.

## New Features

* The Queryable Encryption "String" algorithm (`MONGOC_ENCRYPT_ALGORITHM_STRING`) is now generally available, supporting `prefix`, `suffix`, and `substring` query types.
  * The `prefixPreview`, `suffixPreview`, and `substringPreview` query types remains experimental.
* Snapshot sessions expose APIs to get and set snapshot times.
* Support AWS STS regional endpoints.

## Fixes

* Fix handling of verbose results in `bulkWrite` replies.
* Fix handling of SCRAM replies.


Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung
  * Colby Pike
  * Connor MacDonald
  * Adrian Dole
  * bvalente

libmongoc 2.3.3
===============

## Fixes

* Fix error configuring with CMake 4.4.0.
* Fix issues when built with `UNICODE` on Windows.
* Add stricter validation to HTTP handling.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Colby Pike

libmongoc 2.3.2
===============

## Fixes

* Fix possible abort on failed `killCursors` (introduced in 2.3.0).
* Fix error handling in SCRAM authentication.

Thanks to everyone who contributed to the development of this release.

  * Connor MacDonald
  * Ezra Chung
  * Kevin Albertson


libmongoc 2.3.1
===============

## Improvements

* Improve forward compatibility with OpenSSL 4.0.0 when handling `EAGAIN` errors in old-style read callbacks where `BIO_FLAGS_AUTO_EOF` is enabled.
* Improve decompressed message length constraints.

## Fixes

* Fix documentation generation on Sphinx 9.0+.
* Propagate username to custom OIDC callback.

Thanks to everyone who contributed to the development of this release.

  * Ezra Chung
  * Colby Pike
  * Kevin Albertson

libmongoc 2.3.0
===============

## New Features

* Added support for [MongoDB's Intelligent Workload Management (IWM)](https://www.mongodb.com/docs/atlas/intelligent-workload-management/) and ingress connection rate limiting features. The driver now gracefully handles write-blocking scenarios and optimizes connection establishment during high-load conditions to maintain application availability.
  * Supported on all commands.
  * Custom application retry logic may need to be adjusted to avoid retrying too long.
  * Upgrade is recommended to avoid impacts of server changes related to overload errors.
    * If not upgrading, custom application retry logic may need to be adjusted to handle higher rates of overload errors. See [Overload Errors](https://www.mongodb.com/docs/atlas/overload-errors/?interface=driver&language=c).
  * Add URI option `maxAdaptiveRetries` to configure the maximum number of retries for operations that fail with a `SystemOverloadedError` (default: `2`).
  * Add URI option `enableOverloadRetargeting` to control whether retries of `SystemOverloadedError` will attempt to use a different server (default: `false`).
* Support appending client handshake metadata after initialization and per-client/pool.
  * Adds `mongoc_client_append_metadata` and `mongoc_client_pool_append_metadata`.
  * Useful for projects wrapping the C driver to self-identify.
* Support Kubernetes as a credential provider for `MONGODB-OIDC` authentication.

## Improvements

* Improve cursor handling on client-side timeouts:
  * Send killCursors after cursor receives client-side timeout.
  * Break early if change stream resumes on repeated client-side timeouts.

## Removed

* Support for macOS versions 13 and older. These versions are EOL and not tested. Use macOS version 14 or newer.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Connor MacDonald
  * Ezra Chung
  * GitHub user: user-45-20

## Removed

* Support for macOS versions 13 and older. These versions are EOL and not tested. Use macOS version 14 or newer.

libmongoc 2.2.4
===============

Fixes:

  * Fix handling of corrupt GridFS files.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

libmongoc 1.30.8
================

Fixes:

  * Fix handling of corrupt GridFS files.
  * Fix handling in HTTP response parser.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Remi Collet

libmongoc 2.2.3
===============

## Fixed

* Fix handling in HTTP response parser.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

libmongoc 2.2.2
===============

## Fixed

* Restore $clusterTime on first command of single-threaded client.
* Wait between polling if `serverMonitoringMode=poll` is used on server supporting streaming.

Thanks to everyone who contributed to the development of this release.

  * Connor MacDonald
  * Kevin Albertson

libmongoc 1.30.7
================

Fixes:

  * Documentation build with python-docutils 0.22.2
  * Omit `saslSupportedMechs` in single-threaded monitoring commands.

Thanks to everyone who contributed to the development of this release.

  * Ezra Chung
  * Julia Garland


libmongoc 2.2.1
===============

## Fixed

* Fix applied timeout on Azure and GCP KMS requests.
* Do not error if server reply to bulkWrite omits `nModified`.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson



libmongoc 2.2.0
===============

## New Features

* `MONGODB-OIDC` authentication mechanism.
  * Support a custom callback with `mongoc_client_set_oidc_callback` and `mongoc_client_pool_set_oidc_callback`.
  * Support Azure environment with property `environment:azure`.
  * Support GCP environment with property `environment:gcp`.
  * Kubernetes environment is not-yet supported.
* Add features to `mongoc_bulkwrite_t`:
  * Add `mongoc_bulkwrite_is_acknowledged`.
  * Add `mongoc_bulkwriteresult_serverid`.
  * Support Queryable Encryption.
* Support text indexes for Queryable Encryption:
  * Add `mongoc_client_encryption_encrypt_text_opts_t`.
  * Substring, prefix and suffix search are in preview and should be used for experimental workloads only. These features are unstable and their security is not guaranteed until released as Generally Available (GA). The GA version of these features may not be backwards compatible with the preview version
* Support TLS v1.3 with Windows Secure Channel.

## Fixed

* Do not try to resume when iterating a closed change stream.

## Notes

* Raise required version of libmongocrypt from 1.13.0 to 1.15.0 to support In-Use Encryption (corresponds to the CMake option: `ENABLE_CLIENT_SIDE_ENCRYPTION`).

## Deprecated

* Support for macOS 11 (EOL since September 2023) and macOS 12 (EOL since September 2024).

## Removed

* Support for Visual Studio 2015 (EOL since October 2025). Use Visual Studio 2017 or newer.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Connor MacDonald
  * Julia Garland
  * Ezra Chung
  * Adrian Dole
  * Colby Pike
  * Roberto C. Sánchez
  * shubhamhii

libmongoc 2.1.2
===============

## Fixes

* Fix write command options handling.

Thanks to everyone who contributed to the development of this release.

  * Ezra Chung
  * Kevin Albertson


libmongoc 1.30.6
================

Fixes:

  * Fix write command options handling.

Thanks to everyone who contributed to the development of this release.

  * Ezra Chung
  * Kevin Albertson


libmongoc 2.1.1
===============

## Fixes

* Do not propagate `-fPIC` in CMake targets.
* Apply write command behavior to `mongoc_collection_create_indexes_with_opts`.
* Omit `saslSupportedMechs` in single-threaded monitoring commands.

Thanks to everyone who contributed to the development of this release.

  * Julia Garland
  * Roberto C. Sánchez



libmongoc 2.1.0
===============

## Fixes

* Windows Secure Channel is fixed to support newer signatures to verify client certificates.
* Replace use of `rand()` with thread-safe alternatives.
* The uninstall script for Windows is fixed so it no longer "succeeds" with a non-zero `%ERRORLABEL%` value.
* The uninstall script for non-Windows environments now calls `find "$dir" -maxdepth 1` instead of `ls --almost-all "$dir"` when detecting non-empty directories to fix macOS compatibility.

## Improvements

* Remove unhelpful long-lived buffers to reduce memory usage.
* Improve error messages produced by Windows APIs.

## Notes

* The minimum supported MongoDB Server version is raised from 4.0 to 4.2. This is in accordance with [MongoDB Software Lifecycle Schedules](https://www.mongodb.com/legal/support-policy/lifecycles).

## Changes

* The CMake project now sets a CMake policy max version of `4.0` (previously unset).

## Removed

* Support for Debian 9 and Debian 10.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung
  * Colby Pike
  * Adrian Dole
  * Azat Khuzhin
  * Jeroen Ooms
  * Roberto C. Sánchez
  * Micah Scott


libmongoc 2.0.2
===============

Fixes:

  * Fix message of `bson_strerror_r` on Windows.
  * Fix memory leaks with Windows Secure Channel.
  * Fix loading PKCS#8 RSA keys with Windows Secure Channel.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Colby Pike


libmongoc 1.30.5
================

Fixes:

  * Fix message of `bson_strerror_r` on Windows.
  * Fix memory leaks with Windows Secure Channel.
  * Fix loading PKCS#8 RSA keys with Windows Secure Channel.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Colby Pike


libmongoc 2.0.1
===============

Fixes:

  * Fix username handling for MONGODB-X509 authentication when C driver is configured to use Secure Transport (CMake option `ENABLE_SSL=DARWIN`) or Secure Channel (CMake option `ENABLE_SSL=WINDOWS`).
  * Do not set empty partial result on client error for `mongoc_bulkwrite_execute`.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson


libmongoc 1.30.4
================

Fixes:

  * Fix username handling for MONGODB-X509 authentication when C driver is configured to use Secure Transport (CMake option `ENABLE_SSL=DARWIN`) or Secure Channel (CMake option `ENABLE_SSL=WINDOWS`).
  * Do not set empty partial result on client error for `mongoc_bulkwrite_execute`.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson


libmongoc 1.30.3
================

New Features:

* In anticipation of the 2.0 release of mongo-c-driver, new CMake packages and
  imported targets have been defined (for both `bson` and `mongoc`). To import
  `mongoc` with the new names, call `find_package` for the `mongoc` package. The
  new imported targets are named `mongoc::static`, `mongoc::shared`, and
  `mongoc::mongoc` (which points to either the static or the shared library,
  depending on an import-time configuration option).

  The new package and target names will remain unchanged when upgrading to the
  2.0 release, allowing consumers to support both major versions without
  modifying their CMake project. The current imported target names will be
  removed from the 2.0 release, and should not be used for
  forward-compatibility.

  Programs that link to BSON libraries directly should also use the new target
  names `bson::static`, `bson::shared`, or `bson::bson`.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung
  * Colby Pike

libmongoc 2.0.0
===============

## Notes

* In a future minor release the minimum supported MongoDB Server version will be raised from 4.0 to 4.2. This is in accordance with [MongoDB Software Lifecycle Schedules](https://www.mongodb.com/legal/support-policy/lifecycles).
* Raise required version of libmongocrypt to 1.13.0 to support In-Use Encryption (corresponds to the CMake option: `ENABLE_CLIENT_SIDE_ENCRYPTION`).

## Changes

* Passing `batchSize:0` as an option to `mongoc_client_watch`, `mongoc_database_watch`, or `mongoc_collection_watch`
  now applies `batchSize:0` to the `aggregate` command. Useful to request an immediate cursor. Previously the value
  was ignored.
* `bson_oid_init_sequence` is removed. Use `bson_oid_init` instead.
* `mongoc_server_description_host` changes the return type from `mongoc_host_list_t *` to `const mongoc_host_list_t *`.
* URI authentication credentials validation (only applicable during creation of a new `mongoc_uri_t` object from a connection string):
  * The requirement that a username is non-empty when specified is now enforced regardless of authentication mechanism.
  * Username and password specification requirements are now validated and returns a client error for the specified authentication mechanism.
    * e.g. it is a client error to not specify a username or a password for SCRAM-SHA-1, SCRAM-SHA-256, and PLAIN.
    * e.g. it is a client error to specify a password for MONGODB-X509.
    * e.g. it is a client error to specify a username or a password without the other for MONGODB-AWS.
  * `authSource` is now correctly defaulted to `"$external"` for MONGODB-AWS (instead of the database name or `"admin"`).
  * `authMechanism` is now validated and returns a client error for invalid or unsupported values.
  * `authMechanismProperties` is now validated and returns a client error for invalid or unsupported properties for the specified authentication mechanism.
  * `authMechanismProperties` now correctly supports `':'` within property values.
    * Old behavior: `authMechanismProperties=A:B,C:D:E,F:G` is parsed as `{'A': 'B', 'C': 'D:E,F:G'}`.
    * New behavior: `authMechanismProperties=A:B,C:D:E,F:G` is parsed as `{'A': 'B': 'C': 'D:E', 'F': 'G'}`.
* Calling `mongoc_bulk_operation_execute` on the same `mongoc_bulk_operation_t` repeatedly is an error. Previously this was only discouraged in documentation.
* Consistently apply `__cdecl` calling convention to function declarations in public API. Intended to support consumers building their code using a different [default calling convention](https://learn.microsoft.com/en-us/cpp/build/reference/gd-gr-gv-gz-calling-convention) with MSVC. The mongoc and bson libraries only support being built with the `__cdecl` default calling convention.
* `mongoc_client_set_ssl_opts` now ignores a pooled `mongoc_client_t` and logs an error. Use `mongoc_client_pool_set_ssl_opts` to set TLS options on a `mongoc_client_pool_t` before popping any clients.
* `mongoc_client_set_ssl_stream_initiator` now ignores a pooled `mongoc_client_t` and logs an error.
* The pkg-config files `libmongoc-1.0`, `libmongoc-static-1.0`, `libbson-1.0`,
  and `libbson-static-1.0` have been renamed to `mongoc2`, `mongoc2-static`,
  `bson2`, and `bson2-static`, respectively.

### CMake Packages and Imported Targets

The `mongoc-1.0` (and `bson-1.0`) CMake packages have been removed. Instead, use
`mongoc` or `bson`, and specify a version or version range to be imported:

```cmake
find_package(mongoc 1.30...2.0)
```

The new packages import different target names:

- `mongo::mongoc_static` → `mongoc::static`
- `mongo::mongoc_shared` → `mongoc::shared`
- The target `mongoc::mongoc` is a shim target that points to either the shared
  library or the static library.

The BSON library has had similar name changes.

## Removals

* The `bson_md5_t` struct and associated API is removed.
* The client side matching feature, `mongoc_matcher_t` and related functions are removed.
* `mongoc_server_description_ismaster` is removed. Use the equivalent `mongoc_server_description_hello` instead.
* `MONGOC_QUERY_SLAVE_OK` is removed. Use the equivalent `MONGOC_QUERY_SECONDARY_OK` instead.
* `MONGOC_URI_SLAVEOK` is removed. It was unused.
* `mongoc_client_command`, `mongoc_database_command`, and `mongoc_collection_command` are removed. Use `mongoc_client_command_simple`,  `mongoc_database_command_simple`, and `mongoc_collection_command_simple` instead.
* `MONGOC_URI_MAXIDLETIMEMS` and `MONGOC_URI_WAITQUEUEMULTIPLE` are removed. They were unused.
* `bson_string_t` and associated functions are removed.
* Support for `ENABLE_SASL=CYRUS` on Windows is removed. Use `ENABLE_SASL=SSPI` or `ENABLE_SASL=OFF` instead.
    * The associated Windows-only option `CYRUS_PLUGIN_PATH_PREFIX` is removed.
* Support for the deprecated `minPoolSize` URI option is removed along with associated API: `MONGOC_URI_MINPOOLSIZE` and `mongoc_client_pool_min_size`.
* Support for LibreSSL (the CMake option `ENABLE_SSL=LIBRESSL`) is removed. Associated API is removed (`MONGOC_ENABLE_SSL_LIBRESSL` and  `mongoc_stream_tls_libressl_new`).
* `MONGOC_WRITE_CONCERN_W_ERRORS_IGNORED` (value -1) is removed. Use `MONGOC_WRITE_CONCERN_W_UNACKNOWLEDGED` (value 0) which is handled equivalently. If specified in a URI, replace: `mongodb://host/?w=-1` with `mongodb://host/?w=0`.
* The deprecated CMake option `ENABLE_AUTOMATIC_INIT_AND_CLEANUP` is removed. See [Initialization and cleanup](https://mongoc.org/libmongoc/1.30.2/init-cleanup.html) for expected use of `mongoc_init()` and `mongoc_cleanup()`.
* `mongoc_client_get_database_names` is removed. Use `mongoc_client_get_database_names_with_opts` instead.
* `mongoc_client_find_databases` is removed. Use `mongoc_client_find_databases_with_opts` instead.
* `mongoc_client_get_max_message_size` is removed.
* `mongoc_client_get_max_bson_size` is removed.
* Deprecated `mongoc_apm_command_*_get_server_connection_id` functions are removed. Use `mongoc_apm_command_*_get_server_connection_id_int64` instead.
* Deprecated index management API is removed:
  * `mongoc_collection_create_index_with_opts`, `mongoc_collection_create_index`, and `mongoc_collection_ensure_index` are removed. Use `mongoc_collection_create_indexes_with_opts` instead.
  * `mongoc_index_opt_t`, `mongoc_index_opt_geo_t` `mongoc_index_opt_wt_t` are removed. Pass options using `bson_t` to `mongoc_collection_create_indexes_with_opts` instead.
  * `mongoc_collection_find_indexes` is removed. Use `mongoc_collection_find_indexes_with_opts` instead.
  * See [MongoDB documentation](https://www.mongodb.com/docs/languages/c/c-driver/current/indexes/) for working with indexes.
* Deprecated cursor API is removed:
  * `mongoc_cursor_is_alive` is removed. Use the equivalent `mongoc_cursor_more` instead.
  * `mongoc_cursor_set_hint` is removed. Use the equivalent `mongoc_cursor_set_server_id` instead.
  * `mongoc_cursor_get_hint` is removed. Use the equivalent `mongoc_cursor_get_server_id` instead.
  * `mongoc_cursor_new_from_command_reply` is removed. Use `mongoc_cursor_new_from_command_reply_with_opts` instead.
* Deprecated CRUD API is removed:
  * `mongoc_collection_save` is removed. Use `mongoc_collection_insert_one` or `mongoc_collection_replace_one` instead.
  * `mongoc_collection_delete` is removed. Use `mongoc_collection_delete_one` or `mongoc_collection_delete_many` instead.
  * `mongoc_delete_flags_t` and `mongoc_reply_flags_t` are removed.
  * `mongoc_collection_find` is removed. Use `mongoc_collection_find_with_opts` instead.
  * `mongoc_collection_insert_bulk` is removed. Use `mongoc_collection_insert_many` instead.
  * `mongoc_collection_create_bulk_operation` is removed. Use `mongoc_collection_create_bulk_operation_with_opts` instead.
  * `mongoc_collection_get_last_error` is removed. To get results from write operations, instead use:
      * `mongoc_collection_update_one`
      * `mongoc_collection_update_many`
      * `mongoc_collection_replace_one`
      * `mongoc_collection_delete_one`
      * `mongoc_collection_delete_many`
      * `mongoc_collection_insert_one`
      * `mongoc_collection_insert_many`
      * `mongoc_bulkwrite_t`
      * `mongoc_bulk_operation_t`
  * `mongoc_bulk_operation_delete` is removed. Use `mongoc_bulk_operation_remove()` instead.
  * `mongoc_bulk_operation_delete_one` is removed. Use `mongoc_bulk_operation_remove_one` instead.
  * `mongoc_bulk_operation_get_hint` is removed. Use `mongoc_bulk_operation_get_server_id` instead.
  * `mongoc_bulk_operation_set_hint` is removed. Use `mongoc_bulk_operation_set_server_id` instead.
  * `mongoc_collection_count` and `mongoc_collection_count_with_opts` are removed. Use `mongoc_collection_count_documents` or `mongoc_collection_estimated_document_count` instead.
* `mongoc_collection_stats` is removed. Use the [$collStats aggregation pipeline stage](https://www.mongodb.com/docs/manual/reference/operator/aggregation/collStats/) with `mongoc_collection_aggregate` instead.
* `mongoc_collection_validate` is removed. Run the [validate](https://www.mongodb.com/docs/manual/reference/command/validate/) command directly with `mongoc_client_read_command_with_opts` instead.
* Deprecated API for `mongoc_database_t` is removed:
  * `mongoc_database_find_collections` is removed. Use `mongoc_database_find_collections_with_opts` instead.
  * `mongoc_database_get_collection_names` is removed. Use `mongoc_database_get_collection_names_with_opts` instead.
* Deprecated GridFS API has been removed:
  * `mongoc_gridfs_find` is removed. Use `mongoc_gridfs_find_with_opts` instead.
  * `mongoc_gridfs_find_one` is removed. Use `mongoc_gridfs_find_one_with_opts` instead.
* Deprecated TLS stream API is removed:
  * `mongoc_stream_tls_do_handshake` is removed. Use `mongoc_stream_tls_handshake` instead.
  * `mongoc_stream_tls_check_cert` is removed. Use `mongoc_stream_tls_handshake` instead.
  * `mongoc_stream_tls_new` is removed. Use `mongoc_stream_tls_new_with_hostname` instead.
* Deprecated URI API has been removed:
  * `mongoc_uri_get_service` is removed. Use `mongoc_uri_get_srv_hostname` instead.
  * `mongoc_uri_get_read_prefs` is removed. Use `mongoc_uri_get_read_prefs_t` instead.
  * `mongoc_uri_get_ssl` is removed. Use `mongoc_uri_get_tls` instead.
* Deprecated write concern API is removed:
  * `mongoc_write_concern_get_fsync` is removed. Use `mongoc_write_concern_get_journal` instead.
  * `mongoc_write_concern_set_fsync` is removed. Use `mongoc_write_concern_set_journal` instead.
* The `libmongoc-ssl-1.0` pkg-config file has been removed.

### Forwarding headers (`#include <bson.h>` and `#include <mongoc.h>`)

The compatibility "forwarding" headers have been removed (previously added in 1.13.0). This means it is no longer valid to include the literal header names `mongoc.h` or `bson.h` directly:

```c
#include <bson.h> // No longer provided!
#include <mongoc.h> // No longer provided!
```

Instead, the names must be prefixed with the parent directory: `mongoc/mongoc.h` and `bson/bson.h`:

```c
#include <bson/bson.h>
#include <mongoc/mongoc.h>
```

### `mongoc_client_kill_cursor`

`mongoc_client_kill_cursor` is removed. It did not accept a server identifier. It was only reliable when connected to a single server.

Sending [killCursors](https://www.mongodb.com/docs/manual/reference/command/killCursors/) is not typically needed. `mongoc_cursor_t` manages the cursor lifetime. If needed, use a generic command helper to manually send a `killCursors` command:

```c
bson_t *cmd = BCON_NEW ("killCursors", "coll", "cursors", "[", BCON_INT64 (cursor_id), "]");
bool ok = mongoc_client_command_simple_with_server_id (client, "db", cmd, NULL, server_id, NULL, &error);
if (!ok) {
  printf ("Failed to send 'killCursors': %s\n", error.message);
}
bson_destroy (cmd);
```

### `mongoc_client_get_server_status`

`mongoc_client_get_server_status` is removed. Use a command helper to run the "serverStatus" command instead:

```c
bson_t *cmd = BCON_NEW("serverStatus", BCON_INT32(1));
if (!mongoc_client_command_simple(client, "db", cmd, NULL, &reply, &error)) {
    printf("Failed to send 'serverStatus': %s\n", error.message);
} else {
  // TODO: use `reply`
}
bson_destroy(&reply);
bson_destroy(cmd);
```

## Contributors

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung
  * Colby Pike
  * Micah Scott
  * Jeroen Ooms


libmongoc 1.30.2
================

Fixes:

  * Fix C23 build on Windows.

Thanks to everyone who contributed to the development of this release.

  * Jeroen Ooms

libmongoc 1.30.1
================

No changes since 1.30.0. Version incremented to match the libbson version.

libmongoc 1.30.0
================

Fixes:

  * Additional APM events required by the SDAM specification will now be delivered:
    * Servers that have seen `server_opening` will now see a `server_closed` prior to `topology_closed`.
    * Before `topology_closed`, a `topology_changed` event will transition to `Unknown` topology type.
  * Fix reporting insert IDs in `mongoc_bulkwrite_t` when verbose results requested.

Improvements:

  * Improve performance of `mongoc_server_description_new_copy`.

New Features:

  * Add support for structured logging.
    * See `mongoc_client_set_structured_log_opts` and `mongoc_client_pool_set_structured_log_opts`.
  * Add option to configure cache lifetime of In-Use Encryption data encryption keys.
    * See `mongoc_auto_encryption_opts_set_key_expiration` and `mongoc_client_encryption_opts_set_key_expiration`.
  * Support `sort` option for update and replace operations.
  * Support constructing a `mongoc_bulkwrite_t` without a client.
    * See `mongoc_bulkwrite_new` and `mongoc_bulkwrite_set_client`.

Deprecated:

  * Support for Debian 9 and Debian 10.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Micah Scott
  * Jeremy Mikola
  * Adrian Dole
  * Ezra Chung
  * Antony Polukhin
  * Jeroen Ooms

libmongoc 1.29.2
================

Fixes:
  * Rename `set_error` function to avoid symbol conflicts.
  * Fix Windows ARM 64 build.
  * Fix comparison of uninitialized bytes.
  * Fix format specifier on macOS.

Notes:
  * Windows ARM 64 is not-yet officially tested or supported. Support is community driven.

Thanks to everyone who contributed to the development of this release.

  * Adrian Dole
  * Christian Schmitz
  * Antony Polukhin
  * Kevin Albertson



libmongoc 1.29.1
================

Fixes:

  * Assert session is consistent with client in `mongoc_bulkwrite_set_session`.

Thanks to everyone who contributed to the development of this release.

  * Jeremy Mikola
  * Kevin Albertson



libmongoc 1.29.0
================

Improvements:

  * Retry KMS requests on transient errors.

Platform Support:

  * Support for Visual Studio 2013 is dropped.

Deprecated:

  * `mongoc_client_command` is deprecated and planned for removal in a future release. Use `mongoc_client_command_simple` instead.
  * `mongoc_database_command` is deprecated and planned for removal in a future release. Use `mongoc_database_command_simple` instead.
  * `mongoc_collection_command` is deprecated and planned for removal in a future release. Use `mongoc_collection_command_simple` instead.

Notes:

  * Raise required version of libmongocrypt to 1.12.0 to support In-Use Encryption (corresponds to the CMake option: `ENABLE_CLIENT_SIDE_ENCRYPTION`).
  * A future minor release will raise the minimum supported MongoDB Server version from 4.0 to 4.2. This is in accordance with [MongoDB Software Lifecycle Schedules](https://www.mongodb.com/legal/support-policy/lifecycles). **Support for MongoDB Server 4.0 will be dropped in a future release!**

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung
  * Micah Scott
  * Adrian Dole
  * Andreas Braun
  * Joshua Siegel


libmongoc 1.28.1
================

Fixes:

  * Do not return result in `mongoc_bulkwritereturn_t` if there are no known successful writes.
  * Validate lengths in ill-formed server responses.
  * Do not override read preference when using aggregate with `$out/$merge` with unscanned servers.
  * Remove unexpected warning if `authSource` in TXT record is overriden by URI option.
  * Fix crash when non-existent CA file configured with OpenSSL.

libmongoc 1.28.0
================

New features:

  * Support In-Use Encryption range queries.
  * Include insert ID on result of `mongoc_collection_insert_one`.
  * Add new bulk write API `mongoc_bulkwrite_t`. Requires MongoDB 8.0. Reduces round-trips for mixed writes.
  - Add `serverMonitoringMode` URI option.

Improvements:

  * Improve performance of OpenSSL connection creation.
  * Improve performance when trace logging is configured (`ENABLE_TRACING=ON`) but disabled at runtime.
  * Prefer FIPS compliant functions for SCRAM-SHA-256 key derivation.
  * Remove required slash to delimit options in MongoDB URI (e.g. `mongodb://example.com?w=1` parses the same as `mongodb://example.com/?w=1`).
  * Include topology description in server selection timeout errors.

Notes:

  * Bump minimum wire protocol version from 6 (MongoDB 3.6) to 7 (MongoDB 4.0).
  * Raise required version of libmongocrypt to 1.11.0 to support In-Use Encryption (corresponds to the CMake option: `ENABLE_CLIENT_SIDE_ENCRYPTION`).

Build Configuration:

  * Remove automatic ccache detection and usage (CCache.cmake).
      * Set [`CMAKE_<LANG>_COMPILER_LAUNCHER`](https://cmake.org/cmake/help/latest/envvar/CMAKE_LANG_COMPILER_LAUNCHER.html) to build with ccache.
  * Remove `MONGO_USE_CCACHE` (no longer applicable; see above).

Changed:

  * Test and example targets are excluded from the `ALL` target.
    * All test targets can be built using the `mongo_c_driver_tests` target.
    * All example targets can be built using the `mongo_c_driver_examples` target.
  * Use `#!/usr/bin/env bash` instead of `#!/bin/sh` in uninstall script generated by `ENABLE_UNINSTALL=ON`.

Deprecated:

  * Use of `*_hint` functions is deprecated in favor of more aptly named `*_server_id` functions:
    * `mongoc_bulk_operation_set_hint` is deprecated for `mongoc_bulk_operation_set_server_id`
    * `mongoc_bulk_operation_get_hint` is deprecated for `mongoc_bulk_operation_get_server_id`
    * `mongoc_cursor_set_hint` is deprecated for `mongoc_cursor_set_server_id`
    * `mongoc_cursor_get_hint` is deprecated for `mongoc_cursor_get_server_id`

  * A future minor release plans to drop support for Visual Studio 2013.
  * `ENABLE_SSL=LIBRESSL` is deprecated along with `mongoc_stream_tls_libressl_new`. Support for LibreSSL may be dropped in a future major release.
  * `ENABLE_SASL=CYRUS` on Windows platforms is deprecated. Support for `ENABLE_SASL=CYRUS` on Windows may be dropped in a future major release.
    * The associated Windows-only option `CYRUS_PLUGIN_PATH_PREFIX` is deprecated.

libmongoc 1.27.6
================

Fixes:

  * Fix TSan warning.
  * Fix C23 compile.

Improvements:

  * Document expected behavior of command errors in a transaction.

Thanks to everyone who contributed to the development of this release.

  * Adrian Dole
  * Ezra Chung
  * Joshua Siegel
  * Kevin Albertson



libmongoc 1.27.5
================

Fixes:

  * Fix possible build error in environments where `bool` or `_Bool` is a macro.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson


libmongoc 1.27.4
================

Fixes:

  * Fix possible crash reading malformed wire protocol message.
  * Fix build with Visual Studio 2013.

Thanks to everyone who contributed to the development of this release.

  * Ezra Chung
  * Kevin Albertson



libmongoc 1.27.3
================

Notes:

  * This patch release introduces changes surrounding the development processes,
    including new code signing and dependency tracking. There are no behavioral
    or API changes.

Fixes:

  * Upgraded bundled Zlib from 1.2.3 to 1.3.1

Thanks to everyone who contributed to the development of this release.

  * Colby Pike



libmongoc 1.27.2
================

Fixes:

  * Close leftover connections to removed servers.

New features:

  * Check environment variable `MONGOC_EXPERIMENTAL_SRV_PREFER_TCP` to prefer TCP for SRV lookup.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson



libmongoc 1.27.1
================

No changes since 1.27.0. Version incremented to match the libbson version.

libmongoc 1.27.0
================

Notes:

  * Raise required version of libmongocrypt to 1.10.0 to support In-Use Encryption (corresponds to the CMake option: `ENABLE_CLIENT_SIDE_ENCRYPTION`).
  * A future minor release plans to raise the minimum supported MongoDB Server version from 3.6 to 4.0. This is in accordance with [MongoDB Software Lifecycle Schedules](https://www.mongodb.com/legal/support-policy/lifecycles).

Fixes:

  * Fix possible crash when client is configured with empty password.

New Features:

  * Add database name to command events: `mongoc_apm_command_failed_get_database_name` and `mongoc_apm_command_succeeded_get_database_name`.
  * Support delegated KMIP protocol for In-Use Encryption.
  * Enable setting socket timeout per client.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Adrian Dole
  * Ezra Chung
  * Roberto C. Sánchez
  * Scott Hunt

libmongoc 1.26.2
================

Cyrus SASL:

  * Disable plugin loading with Cyrus SASL on Windows by default. To re-enable, set the CMake option `CYRUS_PLUGIN_PATH_PREFIX` to the absolute path prefix of the Cyrus SASL plugins.

Fixes:

  * Fix possible hang if `mongoc_gridfs_file_readv` is called with a corrupt chunk with incomplete data.
  * Fix assert with legacy exhaust cursor protocol when connected to server < 4.2.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

libmongoc 1.26.1
================

Fixes:

  * Fix 32-bit compile with 64-bit `time_t`

Thanks to everyone who contributed to the development of this release.

  * Roberto C. Sánchez



libmongoc 1.26.0
================

New Features:

  * Support named KMS providers.
  * Redirect retries in sharded clusters to another mongos if possible.

Improvements:

  * Add `VERSION_CURRENT` file in source to ease building.
  * Consider more errors retryable.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Jeremy Mikola
  * Adrian Dole
  * Kyle Kloberdanz
  * Ezra Chung
  * MongoCaleb
  * Roberto C. Sánchez
  * itrofimow



libmongoc 1.25.4
================

Fixes:

  * Restore support for Sphinx 1.7.6 for man page build.

libmongoc 1.25.3
================

Fixes:

  * Disable shared libmongoc targets if `ENABLE_SHARED=OFF`
  * Fix documentation build with Python 3.9.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

libmongoc 1.25.2
================

Fixes:

  * Fix data race in `mongoc_cursor_get_host`.
  * Accept discouraged timeout values for backwards compatibility.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung
  * Kyle Kloberdanz
  * Roberto C. Sánchez

libmongoc 1.25.1
================

Fixes:

  * Add back support for `BUILD_VERSION` CMake option. `BUILD_VERSION` was unintentionally removed in 1.25.0.

libmongoc 1.25.0
================

Fixes:

  * Send `recoveryToken` in transactions when connected to a load balancer.

Improvements:

  * Remove optional dependency of libicu.
  * Use OP_MSG exhaust for mongod >= 4.2. Enable exhaust cursors for mongos >= 7.1.
  * Share cached credentials for SCRAM authentication among all clients to improve performance.
  * Use polling monitoring in FaaS environments.

Build Configuration:

  * Remove `ENABLE_SRV=AUTO`. Only support boolean values for `ENABLE_SRV`.

Platform Support:

  * Support for macOS 10.14 is dropped.
  * Support for Ubuntu 14.04 is dropped.
  * Support for Debian 8.1 is dropped.

Other:

  * The constructed source-distribution archive is no longer available as a
    release artifact. Please instead use the per-release repository archive
    attached to a GitHub release, or clone the repository at the desired release
    tag.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Colby Pike
  * Adrian Dole
  * Roberto C. Sánchez
  * Ezra Chung
  * Joshua Siegel
  * Kyle Kloberdanz
  * Jeremy Mikola

libmongoc 1.24.4
================

Fixes:
  * Fix build failure caused by missing `bson-dsl.h` install in libbson.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

libmongoc 1.24.3
================

Fixes:

  * Fix possible memory leak on SCRAM authentication failure.
  * Fix possible recursive lock on network error in single-threaded client.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Jeremy Mikola
  * Roberto C. Sánchez

libmongoc 1.24.2
================

Fixes:

  * Fix possible crash if thread creation fails.
  * Fix possible assertion if `mongoc_cursor_new_from_command_reply_with_opts` is called with open cursor and no `serverId` option.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

libmongoc 1.24.1
================

Fixes:

    * Remove unnecessary assert in bulk API. May result in an abort when creating bulk operations with the `mongoc_bulk_operation_new` API intended for wrapping drivers.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

libmongoc 1.24.0
================

New Features:

  * Support MongoDB server version 7.0.
  * Support updated Queryable Encryption protocol.
      * Introduces backwards breaking changes to the Queryable Encryption protocol. Using Queryable Encryption now requires MongoDB server version 7.0+.
  * Support new Queryable Encryption features.
      * Add `mongoc_client_encryption_create_encrypted_collection` to automatically create data encryption keys when creating a new encrypted collection.
  * Support new security features.
      * Add ability to fetch KMS credentials automatically from Azure, GCP, and AWS environments.
      * Support authentication with KMS AWS temporary credentials.
      * Cache fetched AWS credentials.
      * Support AWS IAM Roles for service accounts, EKS in particular.
  * Retry operations if the connection handshake fails.
  * Add index creation helper: `mongoc_collection_create_indexes_with_opts`.

Fixes:

  * Fix default applied credentials for Kerberos with SSPI on Windows.
  * Fix possible overcounting in Performance Counters used by `mongoc-stat`.

Language Standard Support:

  * C89 support has been dropped. C99 is the default tested C standard.

Platform Support:

  * Support for macOS 10.14 will be dropped in an upcoming release.
  * Support for Ubuntu 14.04 will be dropped in an upcoming release.
  * Support for Debian 8.1 will be dropped in an upcoming release.

Build Configuration:

  * The `ENABLE_BSON` configure-time option has been removed. Build scripts that
    used `ENABLE_BSON=SYSTEM` should be updated to use `USE_SYSTEM_LIBBSON=TRUE`.
    If the build script needs to support building arbitrary versions of the C
    driver, add both `ENABLE_BSON=SYSTEM` and `USE_SYSTEM_LIBBSON=TRUE`.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung
  * Colby Pike
  * Gil Alon
  * Kyle Kloberdanz
  * Jeremy Mikola
  * Andreas Braun
  * Kondaiah Valagonda
  * Joshua Siegel
  * Roberto C. Sánchez
  * Romain Geissler @ Amadeus
  * bisht2050
  * Adrian Dole

libmongoc 1.23.5
================

Fixes:

  * Fix potential crash due to insufficient memory when allocating performance counters.
  * Fix compilation error on Android platforms due to missing `aligned_alloc`.
  * Return an error if `RewrapManyDataKey` is invoked without a `provider` when a `masterKey` is given.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Romain Geissler @ Amadeus


libmongoc 1.23.4
================

Fixes:

  * Fix possible failure to authenticate with MONGODB-X509 after network error.

Thanks to everyone who contributed to the development of this release.

  * Andreas Braun
  * Kevin Albertson
  * Kyle Kloberdanz



libmongoc 1.23.3
================

Fixes:

  * Better handle malformed `hello` responses
  * Handle `connectionId` of type `double`.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Gil Alon
  * Kondaiah Valagonda



libmongoc 1.23.2
================

Bug fixes:

  * Fix compile on M1 macOS fails due to undeclared function (getpagesize)

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Kyle Kloberdanz


libmongoc 1.22.2
================

  * Fix connectivity to Atlas Data Lake
  * Additional bugfixes from libbson 1.22.2

Thanks to everyone who contributed to the development of this release.

  * Andreas Braun
  * Kevin Albertson
  * Roberto C. Sánchez


libmongoc 1.23.1
================

Bug fixes:

  * Fix connectivity to Atlas Data Lake
  * Fix crash when dropping a malformed Queryable Encryption collection.

Thanks to everyone who contributed to the development of this release.

  * Andreas Braun
  * Kevin Albertson



libmongoc 1.23.0
================

Features:

  * Add on-demand Credentials Callback for CSFLE
  * Support obtaining AWS credentials for CSFLE in the same way as for MONGODB-AWS

Improvements:

  * Reducing Warnings of Misaligned Address of Over-Aligned Types

Bug fixes:

  * Do not spawn mongocryptd if mongo_shared shared library is loaded.

Thanks to everyone who contributed to the development of this release.

  * Ezra Chung
  * Colby Pike
  * Kevin Albertson
  * Roberto C. Sánchez



libmongoc 1.22.1
================

Bug fixes:

  * Fix documentation build when using Sphinx 5.0 or newer
  * Update patch release of libmongocrypt to 1.5.2: Fix a potential data
    corruption bug in RewrapManyDataKey when rotating encrypted data encryption
    keys backed by GCP or Azure key services.

    The following conditions will trigger this bug:

    A GCP-backed or Azure-backed data encryption key being rewrapped requires
    fetching an access token for decryption of the data encryption key.

    The result of this bug is that the key material for all data encryption keys
    being rewrapped is replaced by new randomly generated material, destroying
    the original key material.

    To mitigate potential data corruption, upgrade to this version or higher
    before using RewrapManyDataKey to rotate Azure-backed or GCP-backed data
    encryption keys. A backup of the key vault collection should always be taken
    before key rotation.

Other:

  * Update to Fedora 37 for RPM builds
  * Dependency build of libmongocrypt re-uses the libbson of the depending
    libmongoc

Thanks to everyone who contributed to the development of this release.

  * Ezra Chung
  * Roberto C. Sánchez
  * Kevin Albertson



libmongoc 1.21.2
================

Bug Fixes:
  * Address vulnerability in bundled zlib by updating to 1.1.12.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Colby Pike



libmongoc 1.22.0
================

Bug fixes:

  * Do not auto decrypt before emitting CommandSucceeded events.

Improvements:

  * Use OP_MSG if a server API version is requested.

Features:

  * Add server connectionId to command monitoring events.
  * Add support for the comment field to all helpers.
  * Support mongo_shared shared library.
  * Support pre-point-in-time change stream events.
  * Support Queryable Encryption.
  * Support 'let' option for multiple CRUD commands.
  * Add Key Management API functions.

Notes:

  * The 5.0-compat release (1.18.0) accidentally broke estimatedDocumentCount on views by changing its implementation to use aggregate and a $collStats stage instead of the count command.
  * The new release is fixing estimatedDocumentCount on views by reverting back to using count in its implementation.
  * Due to an oversight, the count command was omitted from the Stable API in server versions 5.0.0 - 5.0.8 and 5.1.0 - 5.3.1, so users of the Stable API with estimatedDocumentCount are recommended to upgrade their MongoDB clusters to 5.0.9 or 5.3.2 (if on Atlas) or set apiStrict: false when constructing their MongoClients.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Jeremy Mikola
  * Colby Pike
  * Ezra Chung
  * Roberto C. Sánchez
  * Jake Molnar
  * Jesse Williamson
  * Remi Collet



libmongoc 1.21.1
================

Bug Fixes:
  * Use static decls for OpenSSL 1.1 polyfills
  * Prevent possible crash in _mongoc_cursor_fetch_stream

Thanks to everyone who contributed to the development of this release.

  * Jeremy Mikola
  * Remi Collet



libmongoc 1.21.0
================

Bug Fixes:
  * Addressed VS 2013 build failures due to missing C99 features.

Features:
 * Support conditional $merge and $out aggregation on secondaries.
 * Bump minimum wire protocol version from 3 (MongoDB 3.0) to 6 (MongoDB 3.6).
 * Bump maximum wire protocol version from 14 (MongoDB 5.1) to 15 (MongODB 5.2).

Improvements:
 * Update algorithm used for generation of OID values to reduce collisions.

Thanks to everyone who contributed to the development of this release.

  * Ezra Chung
  * Colby Pike
  * Kevin Albertson
  * Roberto C. Sánchez
  * David CARLIER
  * Jeremy Mikola



libmongoc 1.20.1
================

Bug fixes:

  * Fix bug where first hello command on a single-threaded client may not include full handshake.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

libmongoc 1.20.0
================

Features:

  * Improve multi-threaded performance of client pool.
  * Support KMIP as a provider for Client-Side Field Level Encryption (CSFLE).

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung
  * Colby Pike
  * Jesse Williamson
  * Jeremy Mikola
  * Kaitlin Mahar

mongo-c-driver 1.19.2
=====================

Announcing libmongoc 1.19.2.

Bug fixes:

* Fix assert on invalid URI options in client pools connected to load balanced clusters when a topology closed callback is registered.

Thanks to everyone who contributed to the development of this release.

--Kevin Albertson

libmongoc 1.19.1
================

It is my pleasure to announce libmongoc 1.19.1.

Bug fixes:

  * Permit NULL platform argument in mongoc_handshake_data_append.
  * Fix wire version check in server selection when maxStalenessSeconds is specified in read preferences.
  * Fix assert on invalid URI options in client pools connected to load balanced clusters.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Ezra Chung

--Kevin Albertson


mongo-c-driver 1.19.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.19.0 release.
This release adds full support for MongoDB 5.0 servers and MongoDB Atlas Serverless Instances.

Features:

  * Add full support to connect to MongoDB Atlas Serverless Instances.
  * Add support for snapshot reads on a session with mongoc_session_opts_set_snapshot.
  * Support the new URI option loadBalanced to connect to a MongoDB cluster behind a TCP load balancer.

Bug fixes:

  * Fix the uploadDate set on newly created GridFS files in the mongoc_gridfs_bucket_t API.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Jeremy Mikola
  * Benjamin Rewis
  * Andreas Braun
  * Colby Pike
  * Ezra Chung
  * Roberto C. Sánchez
  * Jesse Williamson

--Kevin Albertson


mongo-c-driver 1.18.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.18.0 release.
This release adds partial support for MongoDB 5.0 servers.

Features:

  * Introduces support to select an API version when connecting to a MongoDB instance.
  * Supports Azure and Google Cloud Platform as Key Management Service (KMS) providers in Client-Side Field Level Encryption (CSFLE).
  * Support "let" option in aggregate command.
  * Support time series collections.
  * Relax validation for insert and replace documents to support fields containing dots and dollars.
  * Expose the reason operations fail document validation.

Bug fixes:

  * Forward opts from mongoc_gridfs_bucket_find to underlying find operation.
  * Fixes a possible hang when a limited size client pool is waiting for a client to become available in mongoc_client_pool_pop.

Improvements

  * Deprecate API containing deprecated terminology.
  * Use "hello" command for monitoring servers.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Roberto C. Sánchez
  * Andreas Braun
  * Clyde Bazile
  * Benjamin Rewis
  * Jeremy Mikola
  * Andrew Witten
  * Samantha Ritter
  * samantharitter
  * Fermín Galán Márquez
  * David Carlier
  * Colby Pike
  * Josh Weinstein
  * Pierre Mickael Gonzalo

mongo-c-driver 1.18.0-alpha
===========================

It is my pleasure to announce the MongoDB C Driver 1.18.0-alpha.

This is an unstable prerelease and is unsuitable for production applications.

Features:

  * Introduces support to select an API version when connecting to a MongoDB instance.
  * Supports Azure and Google Cloud Platform as Key Management Service (KMS) providers in Client-Side Field Level Encryption (CSFLE)

Bug fixes:

  * Fixes a possible hang when a limited size client pool is waiting for a client to become available in mongoc_client_pool_pop.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Roberto C. Sánchez
  * Clyde Bazile
  * Andreas Braun
  * Andrew Witten
  * Samantha Ritter
  * Benjamin Rewis
  * Fermín Galán Márquez
  * David Carlier
  * Josh Weinstein
  * Pierre Mickael Gonzalo

mongo-c-driver 1.17.7
=====================

It is my pleasure to announce the MongoDB C Driver 1.17.7.

- Print correct error message when DNS resolution fails
- Mix time to avoid duplicate RAND_bytes for the same PIDs

Thanks to everyone who contributed to the development of this release.

  * Andreas Braun
  * Jeremy Mikola

--Kevin Albertson


mongo-c-driver 1.17.6
=====================

It is my pleasure to announce the MongoDB C Driver 1.17.6.

Bug fixes:

  * Fix possible crash when speculative authentication fails with network error.

Thanks to everyone who contributed to the development of this release.

  * Andreas Braun

--Kevin Albertson


mongo-c-driver 1.17.5
=====================

It is my pleasure to announce the MongoDB C Driver 1.17.5.

Improvements:

  * Fix documentation regarding when to call mongoc_log_set_handler

Thanks to everyone who contributed to the development of this release.

  * Clyde Bazile
  * Fermín Galán Márquez

--Kevin Albertson


mongo-c-driver 1.17.4
=====================

It is my pleasure to announce the MongoDB C Driver 1.17.4.

Bug fixes:

  * Fix crash on macOS on client pool shutdown.
  * Fix spacing in extended JSON output for numberLong.
  * Clear error in mongoc_collection_find_and_modify_with_opts on a successful retry.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Samantha Ritter

-- Kevin Albertson


mongo-c-driver 1.17.3
=====================

It is my pleasure to announce the MongoDB C Driver 1.17.3.

Bug fixes:

  * Do not send session ID on GSSAPI auth commands.
  * Fix build against zlib when zlib is installed in non-standard location.
  * Fix build when source directory path contains a space.
  * Fix a platform-specific bug causing mongoc_client_pool_pop to block indefinitely if all clients are checked out.
  * Fix a possible buffer overflow with hostnames resolving to IPv6 addresses on OpenSSL.


Thanks to everyone who contributed to the development of this release.

  * Roberto C. Sánchez
  * Kevin Albertson
  * Andrew Witten
  * gonzalo

-- Kevin Albertson


mongo-c-driver 1.17.2
=====================

It is my pleasure to announce the MongoDB C Driver 1.17.2.

Bug fixes:

  * Stop the SRV polling thread when an SRV URI is used to connect to a deployment other than a sharded cluster.

Thanks to everyone who contributed to the development of this release.

  * Roberto C. Sánchez
  * Kevin Albertson

-- Kevin Albertson


mongo-c-driver 1.17.1
=====================

It is my pleasure to announce the MongoDB C Driver 1.17.1.

Bug fixes:

  * Fix SRV/TXT record lookup for DNS records exceeding 1024 bytes.

-- Kevin Albertson


mongo-c-driver 1.17.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.17.0 release.
This release adds support for MongoDB 4.4 servers.

Features:

  * Support streamable server monitoring to reduce recovery time when the server topology changes.
  * Support the MONGODB-AWS authentication mechanism.
  * Support Online Certificate Status Protocol (OCSP).
  * Support configuring hedged reads in read preferences.
  * Reduce the number of round trips necessary for SCRAM and X509 authentication.
  * Monitor servers in parallel when using a mongoc_client_pool_t instead of doing serial scans.
  * Support the "hint" option in operations using the update, replace, delete, and findAndModify commands.
  * Improve behavior for retryable writes.
  * Improve resuming behavior of change streams on server errors.
  * Remove restriction of 255 character collection namespaces.

Bug fixes:

  * Fix criteria for resumable errors in change streams.
  * Fix rare crashes when server is invalidated during authentication.
  * Reject client session for mongoc_collection_estimated_document_count.
  * Fix behavior of a SecondaryPreferred read preference for exhaust cursor operations against a sharded cluster. Prior to the fix, a nonzero maxStalenessSeconds would not trigger sending the read preference.
  * Fix SRV polling. Prior to the fix, SRV polling did not properly apply newly discovered results.
  * Fix checks for existing GridFS indexes to handle indexes created by the MongoDB shell.
  * Fix possible use of invalidated streams during an unordered OP_QUERY bulk write, and when ending many pooled sessions at client destruction.
  * Fix a crash when setting the crl_file TLS option for Secure Channel.
  * Avoid emitting duplicate ServerChanged events when no change is observed during monitoring.
  * Properly handle large SASL messages instead of erroring.

Notes:

  * Deprecated "lib" prefixed artifacts are no longer produced when building on Windows.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Roberto C. Sánchez
  * Andrew Witten
  * Andreas Braun
  * Clyde Bazile
  * Josh Weinstein

-- Kevin Albertson

mongo-c-driver 1.17.0 rc0
=========================

It is my pleasure to announce the MongoDB C Driver 1.17.0 rc0 release.
This release adds support for MongoDB 4.4 servers.

Features:

  * Support streamable server monitoring to reduce recovery time when the server topology changes.
  * Support tlsDisableCertificateRevocationCheck when built with Secure Channel.

Bug fixes:

  * Fix criteria for resumable errors in change streams.
  * Fix rare crashes when server is invalidated during authentication.
  * Improve behavior when reaching out to OCSP responders for certificate revocation checking.
  * Reject client session for mongoc_collection_estimated_document_count.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Andrew Witten
  * Roberto C. Sánchez
  * Clyde Bazile

-- Kevin Albertson

mongo-c-driver 1.17.0 beta2
===========================

It is my pleasure to announce the MongoDB C Driver 1.17.0 beta2 release.

Features:

  * Support Online Certificate Status Protocol (OCSP) response caching.
  * Support configuring hedged reads in read preferences.
  * Reduce the number of round trips necessary for SCRAM and X509 authentication.
  * Monitor servers in parallel when using a mongoc_client_pool_t instead of doing serial scans.
  * Support OCSP on older versions of OpenSSL (1.0.1+).

Bug fixes:

  * Fix behavior of a SecondaryPreferred read preference for exhaust cursor operations against a sharded cluster. Prior to the fix, a nonzero maxStalenessSeconds would not trigger sending the read preference.
  * Fix SRV polling. Prior to the fix, SRV polling did not properly apply newly discovered results.
  * Fix checks for existing GridFS indexes to handle indexes created by the MongoDB shell.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Roberto C. Sánchez
  * Andreas Braun
  * Clyde Bazile
  * Josh Weinstein

-- Kevin Albertson


mongo-c-driver 1.17.0 beta
==========================

It is my pleasure to announce the MongoDB C Driver 1.17.0 beta release.

Features:

  * Support the MONGODB-AWS authentication mechanism.
  * Support the Online Certificate Status Protocol (OCSP) for OpenSSL 1.1.0+, Secure Transport, and Secure Channel.
  * Support the "hint" option in operations using the update, replace, delete, and findAndModify commands.
  * Improve behavior for retryable writes.
  * Improve resuming behavior of change streams on server errors.
  * Remove an extra round trip for SCRAM authentication.
  * Remove restriction of 255 character collection namespaces.

Bug fixes:

  * Fix possible use of invalidated streams during an unordered OP_QUERY bulk write, and when ending many pooled sessions at client destruction.
  * Fix a crash when setting the crl_file TLS option for Secure Channel.
  * Avoid emitting duplicate ServerChanged events when no change is observed during monitoring.
  * Properly handle large SASL messages instead of erroring.

Notes:

  * Deprecated "lib" prefixed artifacts are no longer produced when building on Windows.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Roberto C. Sánchez
  * Andreas Braun
  * Clyde Bazile
  * Jeremy Mikola
  * Sara Golemon

-- Kevin Albertson


mongo-c-driver 1.16.1
=====================

It is my pleasure to announce the MongoDB C Driver 1.16.1.

Bug fixes:

  * Fix listed library dependency on mongoc_static target when building with libmongocrypt.
  * Replace a call of free to bson_free.
  * Vendor Sphinx basic theme and correctly list static files for docs.
  * Fix a compilation warning introduced in 1.16.0.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson

Peace,

    Kevin Albertson


mongo-c-driver 1.16.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.16.0.

Features:

  * Support Client-side Field Level Encryption.
  * Support ability to pass an index hint to update operations.
  * Add cmake export targets.

Bug fixes:
  * Fix a bug with Windows SSPI failing to authenticate with GSSAPI when using
    pooled clients for certain operations.
  * Fix behavior for bulk writes that retry to keep track of the successful server.
  * Remove hard limit of 1024 characters for SRV response.
  * Fix racy crash when using client pool against a sharded cluster if a server is invalidated shortly before a new socket is opened against it.
  * Remove unnecessary library dependencies causing overlinking.
  * Ensure server proof has been validated during SCRAM conversation.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Jeremy Mikola
  * Clyde Bazile
  * Andreas Braun
  * Roberto C. Sánchez
  * Samantha Ritter
  * Isabel Atkinson
  * Kaitlin Mahar
  * Diego Barrios Romero
  * Sara Golemon
  * Vasil Velichkov
  * EGuesnet

Peace,

    Kevin Albertson

mongo-c-driver 1.15.3
=====================

It is my pleasure to announce the MongoDB C Driver 1.15.3.

Bug fixes:
    * Fix a hang on macOS when connecting to a server over TLS
    * Add zstd as a dependency when libmongoc static library is compiled with zstd support
    * Fix compilation on AIX 6.1

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Samantha Ritter
  * EGuesnet

mongo-c-driver 1.15.2
=====================

It is my pleasure to announce the MongoDB C Driver 1.15.2.

Bug fixes:
   * Prevent mongoc_transaction_opts_set_max_commit_time_ms from applying to subsequent transactions that should be using the default.
   * Do not report the initial error if a retry for a change stream function (mongoc_collection_watch, mongoc_database_watch, or mongoc_client_watch) succeeds

Thanks to everyone who contributed to the development of this release.

  * Andreas Braun
  * Clyde Bazile

Peace,

    Kevin Albertson


mongo-c-driver 1.15.1
=====================

It is my pleasure to announce the MongoDB C Driver 1.15.1.

Bug fixes:
   * Fix change stream resume logic when no documents received
   * Reduce the required cmake version to build with zstd support
   * Minor fixes to mongos pinning logic
   * Do not resume a change stream on NonResumableChangeStreamError

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Clyde Bazile

Peace,

    Clyde Bazile

mongo-c-driver 1.15.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.15.0. This release adds
support for MongoDB 4.2 features.

Features:

  * Support for sharded transactions on MongoDB sharded clusters 4.2+.
  * Add convenient transaction runner (mongoc_client_session_with_transaction),
    which accepts a callback and performs appropriate retry logic.
  * Add a new transaction option to specify maximum time to wait for a commit,
    mongoc_transaction_opts_set_max_commit_time_ms.
  * Add URI option "retryReads=true" safely and automatically retries certain
    read operations if the server is a MongoDB 3.6+.
  * Poll SRV records to mongos servers periodically.
  * Keep connections alive after a primary stepdown detected.
  * Standardizes URI options supported across all spec-compliant MongoDB drivers.
  * "retryWrites" URI option now defaults to true (requires crypto for session
    support).
  * Send any aggregate with $out or $merge stage to a primary.
  * Add the ability to specify an aggregate pipeline as an update document.
  * Add a database aggregate helper, mongoc_database_aggregate.
  * Add option for change streams, "startAfter".
  * Add mongoc_change_stream_get_resume_token, which returns the resume token
    which should be used to resume a change stream.
  * Add support for zstd compression.

Bug fixes:
  * Correctly report an error in mongoc_change_stream_next if the resume token
    (_id) is not a document. Previously, an error was only reported if the
    field was missing.
  * Fix mongoc_collection_update with MONGOC_UPDATE_MULTI_UPDATE,
    mongoc_collection_remove, and mongoc_collection_delete when retryWrites
    was enabled. They would fail previously.
  * Command options are now correctly taken into account when batching bulk
    writes for OP_QUERY. It was possible to exceed the maximum document size
    before.
  * Fix a crash if a multi-batch bulk write with OP_MSG errored on a batch.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * Jeremy Mikola
  * Haris Sheikh
  * Samantha Ritter
  * Isabel Atkinson
  * Sara Golemon
  * Clyde Bazile
  * Roberto C. Sánchez
  * Lior Kaplan
  * pasniak

Peace,

    Kevin Albertson


mongo-c-driver 1.14.1
=====================

It is my pleasure to announce the MongoDB C Driver 1.14.1.

Bug fixes:

  * Prohibit starting a transaction for pre-4.0 MongoDB servers.
  * Prohibit starting a sharded transaction for pre-4.2 MongoDB servers.

Thanks to everyone who contributed to the development of this release.

  * Jeremy Mikola
  * Clyde Bazile

Peace,

    Kevin Albertson


mongo-c-driver 1.14.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.14.0.


Features:

  * Support for OpenSSL 1.1.1 and its implementation of TLS v1.3.
  * New function mongoc_stream_should_retry.
  * New accessor mongoc_server_description_last_update_time.
  * New method mongoc_client_reset to be called after forking.

Bug fixes:

  * OP_MSG with unacknowledged writes (write concern of w:0) would serialize
    incorrectly on big-endian platforms, causing writes to use the default
    write concern of w:1.
  * mongoc_collection_update_many and mongoc_collection_delete_many would fail
    with the URI option retryWrites=true.
  * In a transaction, the driver now properly ignores the readConcern configured
    on a client, database, or collection: only the mongoc_transaction_opt_t's
    readConcern is used.
  * Remove timestamp from uninstall scripts to permit reproducible build.
  * Setting mongoc_ssl_opt_t.pem_file or ca_file to a bad file path caused a
    hang with Darwin SSL.
  * Fix the ENABLE_SASL cmake option:
    * Remove unnecessary GSSAPI value. It was equivalent to specifying ENABLE_SASL=CYRUS.
    * ENABLE_SASL=AUTO now correctly chooses SSPI on Windows instead of CYRUS.
  * The client pool failed to set proper apm callbacks for clients created
    via try_pop().


Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Roberto C. Sánchez
  * Kevin Albertson
  * Samantha Ritter
  * Spencer McKenney
  * Henrik Edin
  * Jeremy Mikola
  * Evgeni Dobranov
  * Derick Rethans
  * 平民·寻梦(Pingmin Fenlly Liu)
  * David Carlier
  * Gustaf Neumann
  * Jeroen
  * Jeroen Ooms
  * Kaitlin Mahar
  * Tomas Mozes
  * Clyde Bazile

Peace,

    Samantha Ritter


mongo-c-driver 1.13.1
=====================

It is my pleasure to announce the MongoDB C Driver 1.13.1.

Bug fixes:

  * mongoc_collection_update_many and mongoc_collection_delete_many would fail
    with the URI option retryWrites=true.
  * Remove timestamp from uninstall scripts to permit reproducible build.
  * Add missing header files to the release tarball to fix compilation when
    configuring with ENABLE_SASL=GSSAPI.
  * Separate libmongoc and libbson uninstall scripts so they do not overwrite
    each other.
  * Fix running make install with DESTDIR.

Thanks to everyone who contributed to the development of this release.

  * Kevin Albertson
  * A. Jesse Jiryu Davis
  * Henrik Edin

Peace,

    Kevin Albertson


mongo-c-driver 1.13.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.13.0.

Features:

  * Report a new error code, MONGOC_ERROR_GRIDFS_CORRUPT, when a chunk larger
    than chunkSize is detected. Before, the driver had crashed with an assert.
  * Restructure of install directory. All mongoc headers are under mongoc/
    and all bson headers are under bson/. The preferred way of including the
    headers are mongoc/mongoc.h and bson/bson.h respectively.
    Forwarding headers in the root are provided for backwards compatibility.
    (**Update**: These headers were removed in the 2.0 release)
  * The default CMake build type had been unspecified, now it is RelWithDebInfo.
  * Support LibreSSL 2.7+.

Bug fixes:

  * mongoc_collection_replace_one is now a correctly exported symbol.
  * Fix multiple issues with readConcern and writeConcern inheritance.
  * Fix rare crash with mongodb+srv URIs on Windows.
  * mongoc_gridfs_create_file_from_stream ignored errors while writing chunks
    to the server.
  * The following functions should not have taken a "bypassDocumentValidation"
    option in bson_t *opts, the option is now prohibited:
    - mongoc_bulk_operation_insert_with_opts
    - mongoc_bulk_operation_update_one_with_opts
    - mongoc_bulk_operation_update_many_with_opts
    - mongoc_bulk_operation_replace_one_with_opts
  * The heartbeat-succeeded and heartbeat-failed events (part of SDAM
    Monitoring) had uninitialized "duration" fields, they are now set correctly.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Roberto C. Sánchez
  * Kevin Albertson
  * Henrik Edin
  * Spencer McKenney
  * Jeremy Mikola
  * Evgeni Dobranov
  * Tomas Mozes
  * Derick Rethans
  * Gustaf Neumann
  * Jeroen Ooms
  * Kaitlin Mahar

Peace,

    Kevin Albertson


mongo-c-driver 1.12.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.12.0.

Features:

  * New function mongoc_client_session_in_transaction to check if a multi-
    document transaction is started.
  * New examples for change streams and transactions, improved guide for
    migrating from mongoc_collection_count to mongoc_collection_count_documents

Bug fixes:

  * Fix occasional crash in sharded queries
  * Retry all retryable write concern errors
  * mongoc_client_session_commit_transaction sets the correct error label when
    the primary is unavailable
  * mongoc_collection_find_with_opts had prohibited read preference "primary"
    in a transaction
  * mongoc_collection_aggregate had not inherited its mongoc_collection_t's
    read preference; only an explicitly provided read preference was used.
  * Allow unencoded delimiters in username/password if unambiguous

Thanks to everyone who contributed to the development of this release.

  * Roberto C. Sánchez
  * A. Jesse Jiryu Davis
  * Kevin Albertson
  * Spencer McKenney
  * Evgeni Dobranov
  * Jeremy Mikola
  * 平民·寻梦(Pingmin Fenlly Liu)

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.11.0
=====================

It is my pleasure to announce the MongoDB C Driver 1.11.0. This release adds
support for MongoDB 4.0 features. It includes the following additions and
improvements:

  * Multi-document transactions, see mongoc_client_session_start_transaction
  * New function mongoc_error_has_label to check for specific error labels such
    as "TransientTransactionError" or "UnknownTransactionCommitResult" in
    error replies.
  * New functions to subscribe to changes on an entire client or database:
    - mongoc_client_watch
    - mongoc_database_watch
  * New option for change streams, "startAtOperationTime".
  * mongoc_collection_count_with_opts is deprecated for two new functions:
    - mongoc_collection_count_documents
    - mongoc_collection_estimated_document_count
  * Support for SCRAM-SHA-256 authentication, including support for non-ASCII
    passwords using libicu is an optional dependency.
  * Faster mongoc_database_get_collection_names_with_opts fetches only names,
    not the entire collection metadata.

Additional changes not specific to MongoDB 4.0:

  * All "destroy" functions such as mongoc_collection_destroy now ignore a NULL
    argument.
  * The driver now returns an error if you attempt to use "arrayFilters" in an
    update with a MongoDB server older than 3.6.
  * Update functions include a new "upsertedCount" field in the reply document.
  * Replace MD5 with FNV-1a hash to generate ObjectIds (for FIPS compliance).

Bug fixes:

  * Functions incorrectly marked with the "const" compiler attribute are now
    marked as "pure", fixes build error when link-time optimization is enabled.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Kevin Albertson
  * Evgeni Dobranov
  * Spencer McKenney
  * Jeremy Mikola
  * Roberto C. Sánchez
  * Remi Collet

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.10.3
=====================

No change since 1.10.2; released to keep pace with libbson's version.

-- A. Jesse Jiryu Davis


mongo-c-driver 1.10.2
=====================

It is my pleasure to announce the MongoDB C Driver 1.10.2. This release fixes
the libbson and libmongoc installed library filenames and SONAMEs on Linux.
They had changed unintentionally with the switch to CMake in 1.10.0; they are
now consistent with 1.9.x and previous releases. Thanks to Roberto C. Sánchez
for the fix.

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.10.1
=====================

It is my pleasure to announce the MongoDB C Driver 1.10.1. This release fixes
the following bugs introduced in version 1.10.0:

  * Client sessions were not prohibited with unacknowledged write concern and
    mongoc_bulk_operation_execute; now they are prohibited. Client sessions have
    been prohibited with all other unacknowledged writes since 1.10.
  * The "arrayFilters" update option, new in MongoDB 3.6 and supported since
    libmongoc 1.9.0, was inadvertently prohibited by
    mongoc_bulk_operation_update_one_with_opts and
    mongoc_bulk_operation_update_many_with_opts in 1.10. The option is now
    permitted again.
  * The mongoc-stat tool for displaying shared counters was disabled on Linux
    and not installed; it is now restored.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Jeremy Mikola
  * Remi Collet

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.10.0
=====================

It is my pleasure to announce MongoDB C Driver 1.10.0. This version drops
support for MongoDB 2.6 and adds the following features and bugfixes:

  * libbson and libmongoc are now maintained in the mongo-c-driver repository,
    although they are still built as separate libraries, and libbson can still
    be used without libmongoc.
  * Building libbson and libmongoc now requires CMake on all platforms. The
    Autotools build scripts ("configure" and related scripts) have been deleted.
    See the "installing" page for updated instructions, including the new
    ENABLE_MONGOC option and changes to the ENABLE_BSON option.
  * IPv6 is now fully supported and conforms to RFC-6555. If a hostname has both
    IPv4 and IPv6 DNS records, the driver tries connecting with IPv6 first. If a
    connection can't be established after 250ms then IPv4 is tried in parallel.
    Whichever succeeds connection first cancels the other. The successful DNS
    result is cached for 10 minutes.
  * If CMake is configured with ENABLE_SSL=AUTO (the default), libmongoc now
    uses native TLS libraries on Mac and Windows, and OpenSSL everywhere else.
    Before, it would search for OpenSSL on all platforms and only use native
    TLS on Mac and Windows as a fallback.
  * The driver now handshakes SSL connections to multiple servers in a replica
    set or sharded cluster in parallel, so long as it uses OpenSSL or Windows
    SChannel. (SSL handshakes with Apple's Secure Transport are still serial.)
    A larger receive buffer with SChannel increases performance over slow
    connections.
  * All functions that accept read concern now prohibit it, if MongoDB is too
    old to support it (MongoDB 3.0).
  * Client sessions are now prohibited with unacknowledged writes.
  * mongoc_collection_find_and_modify_with_opts now prohibits write concern if
    MongoDB is too old to support it (MongoDB 3.0).
  * Other helper functions for commands that write, now prohibit write concern
    if MongoDB is too old to support it (pre-3.4):
      mongoc_client_read_write_command_with_opts
      mongoc_client_write_command_with_opts
      mongoc_collection_read_write_command_with_opts
      mongoc_collection_write_command_with_opts
      mongoc_database_read_write_command_with_opts
      mongoc_database_write_command_with_opts
      mongoc_collection_aggregate with $out
      mongoc_collection_drop_index_with_opts
      mongoc_collection_drop_with_opts
      mongoc_collection_rename_with_opts
      mongoc_database_drop_with_opts
    Write concern behavior is unchanged for regular CRUD functions.
  * Setting a negative writeConcern level of -2 or smaller, via the "opts"
    parameter to functions that accept BSON options, is now prohibited. The
    special "w" values -2 through -4 are only used internally. The deprecated
    "w=-1" is still allowed, as a synonym for "w=0".
  * The Kerberos URI option authMechanismProperties=CANONICALIZE_HOST_NAME:true
    is now implemented with the Windows Kerberos provider, SSPI.
  * This repository now includes GDB and LLDB customizations for pretty-printing
    bson_t structs as JSON while debugging. See the "debugging" page.
  * The internal preprocessor symbol HAVE_STRINGS_H has been renamed
    BSON_HAVE_STRINGS_H. If you maintain a handwritten bson-config.h you must
    rename this symbol.
  * The following helper functions do not work with mongoc_client_session_t,
    they are deprecated in favor of running MongoDB commands directly with a
    function like mongoc_client_read_command_with_opts:
      mongoc_client_get_server_status
      mongoc_collection_stats
      mongoc_collection_validate
  * mongoc_cursor_is_alive is now deprecated for mongoc_cursor_more, which is
    functionally equivalent.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Kevin Albertson
  * Roberto C. Sánchez
  * Jeremy Mikola
  * Xiangyu Yao
  * Jeroen Ooms
  * Derick Rethans
  * Kaitlin Mahar
  * Pavithra Vetriselvan
  * NotSpooky
  * Iulian Rotaru
  * Katherine Walker

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.9.5
====================

It is my pleasure to announce mongo-c-driver 1.9.5. This release fixes the following bugs:

  * New change streams API functions were not marked extern "C"
  * mongoc_collection_watch now accepts a pipeline argument as a BSON array, in
    addition to accepting a BSON document with a "pipeline" array field
  * Crashes in several change stream error handling paths
  * Commands could return false with an empty bson_error_t after a replica set
    reconfig
  * Network error messages omitted the command name when using OP_MSG

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Kevin Albertson

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.9.4
====================

It is my pleasure to announce mongo-c-driver 1.9.4. This release offers
compatibility with Sphinx 1.7.0 and above and fixes two bugs:

  * Ensure a change stream uses the proper session id while iterating
  * Fix a rare crash in pooled mode when a replica set member was disconnected

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Kevin Albertson

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.9.3
====================

It is my pleasure to announce mongo-c-driver 1.9.3. This version fixes a
session-management bug that could cause an authentication error while connected
to MongoDB 3.6+ and iterating a cursor, and it permits the $gleStats modifier
with mongoc_collection_aggregate.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Jeremy Mikola

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.9.2
====================

No change since 1.9.1; released to keep pace with libbson's version number.

-- A. Jesse Jiryu Davis


mongo-c-driver 1.9.1
====================

It is my pleasure to announce mongo-c-driver 1.9.1. This release fixes a bug
that caused session ID to be included in authentication and server monitoring
commands. Thanks to Jeremy Mikola for finding and fixing the issue.

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.9.0
====================

It is my pleasure to announce mongo-c-driver 1.9.0. This version drops support
for MongoDB 2.4 and adds support for MongoDB 3.6 features:

  * New struct mongoc_change_stream_t to watch a collection for changes.
  * New struct mongoc_client_session_t represents a MongoDB 3.6 session,
    which supports causal consistency: you are guaranteed to read your writes
    and to perform monotonic reads, even when reading from secondaries or in
    a sharded cluster.
  * New functions that accept flexible options as a BSON document. These
    accept a "sessionId" option and any future options. In addition, the
    two new "update" functions accept the "arrayFilters" option that is new
    in MongoDB 3.6:
      mongoc_collection_insert_one
      mongoc_collection_insert_many
      mongoc_collection_update_one
      mongoc_collection_update_many
      mongoc_collection_replace_one
      mongoc_collection_delete_one
      mongoc_collection_delete_many
      mongoc_client_command_with_opts
      mongoc_database_command_with_opts
      mongoc_collection_command_with_opts
      mongoc_client_find_databases_with_opts
      mongoc_client_get_database_names_with_opts
      mongoc_collection_create_bulk_operation_with_opts
      mongoc_collection_find_indexes_with_opts
      mongoc_database_find_collections_with_opts
      mongoc_database_get_collection_names_with_opts
  * New URI option "retryWrites=true" safely and automatically retries certain
    write operations if the server is a MongoDB 3.6 replica set or sharded
    cluster.
  * Support for MongoDB OP_MSG wire protocol.

Additional changes not specific to MongoDB 3.6:

  * Support for mongodb+srv URIs to query DNS for SRV and TXT records that
    configure the connection to MongoDB.
  * Support LibreSSL with CMake build
  * The "minPoolSize" URI option is deprecated: it's confusing and not useful.

Bug fixes:

  * mongoc_bulk_operation_execute did not always initialize "reply".
  * Fix C99 pedantic warnings.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Jeremy Mikola
  * Kevin Albertson
  * Jeroen Ooms
  * Iulian Rotaru
  * Derick Rethans
  * Graham Whitted
  * Brian Moss
  * Alex Masterov
  * Michael Kuhn
  * Sriharsha Vardhan

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.8.2
====================

It is my pleasure to announce mongo-c-driver 1.8.2. This release fixes the
following bugs:

  * Remove option to bundle the Snappy compression library, it caused issues
    for programs linking to libmongoc
  * Fix pkg-config and CMake config file flags for programs that statically
    link to libmongoc when libmongoc is statically linked to zLib
  * The configure flag "--with-zlib=no" was ignored
    Crash in authentication when username is NULL

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Derick Rethans
  * Hannes Magnusson
  * Jeremy Mikola

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.8.1
====================

It is my pleasure to announce mongo-c-driver 1.8.1. This release fixes the
following bugs:

  * Remove a syntax error in the configure script that affects some shells.
  * The configure script respects --with-zlib=system and --with-snappy=system.
  * The internal mongoc_server_description_t struct is properly reinitialized
    after a network error.
  * Fix the encoding of this NEWS file.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Jeremy Mikola

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.8.0
====================

  * The zLib and Snappy compression libraries are bundled if not available.
    Wire protocol compression is enabled on Windows.
  * mongoc_collection_find_and_modify_with_opts now respects a "writeConcern"
    field in the "extra" BSON document in its mongoc_find_and_modify_opts_t.
  * The command functions mongoc_client_read_write_command_with_opts,
    mongoc_database_read_write_command_with_opts, and
    mongoc_collection_read_write_command_with_opts now ignore the "read_prefs"
    parameter.
  * mongoc_collection_create_index and mongoc_collection_create_index_with_opts
    are both now deprecated. Use mongoc_database_write_command_with_opts
    instead; a guide to creating an index using that function has been added.
  * Use select, not WSAPoll, on Windows.
  * Always mark a server "Unknown" after a network error (besides a timeout).
  * mongoc_client_pool_t sends platform metadata to the server; before, only a
    single mongoc_client_t did.
  * New stream method mongoc_stream_timed_out.
  * Wire version checks introduced in 1.8.0 will prevent the driver from
    connecting to a future MongoDB server version if its wire protocol is
    incompatible.
  * New CMake option ENABLE_MAINTAINER_FLAGS.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Jeremy Mikola

Peace,

   A. Jesse Jiryu Davis


mongo-c-driver 1.7.0
====================

It is my pleasure to announce mongo-c-driver 1.7.0.

New features and bug fixes:

  * CMake build now installs .pc files for programs that link to libmongoc using
    pkg-config. Both the CMake and Autotools build systems now install .cmake
    files for programs that link to libmongoc using CMake. Linking to libmongoc
    statically or dynamically is now much more convenient. See the new tutorial
    section "Include and link libmongoc in your C program".
  * New CMake option ENABLE_STATIC can be ON, OFF, or AUTO (the default)
  * Minimum required CMake version has been increased to 3.1.
  * CMake remains experimental on non-Windows platforms and issues a warning now
  * Support for wire compression.
    * Support for snappy and zlib. MongoDB 3.4 only supports snappy, while zlib
      support is expected in MongoDB 3.6.
      The enable, configure mongoc like so:
      ./configure --with-snappy --with-zlib
    * New functions: mongoc_uri_get_compressors & mongoc_uri_set_compressors, to
      get and set compressor configuration on mongoc_uri_t
    * Added support for comma separated "compressors" connection string option (e.g.
      mongodb://localhost/?compressors=snappy,zlib)
    * Added support for configuring zlib compression level in the connection string
      (e.g. mongodb://localhost/?compressors=zlib&zlibcompressionlevel=8)
  * Now requires the use of CMake config files for libbson to build libmongoc
    with CMake
  * Added pkg-config support for libressl.
  * New function mongoc_uri_set_auth_mechanism to update the authentication
    mechanism of a mongoc_uri_t after it is created from a string.
  * New function mongoc_bulk_operation_insert_with_opts provides immediate
    error checking.
  * New function mongoc_uri_new_with_error provides a way to parse a connection
    string, and retrieve the failure reason, if any.
  * Support for MongoDB Connection String specification
    * All connection string options are now represented by MONGOC_URI_xxx macros
    * Paths to Unix Domain Sockets must be url encoded
    * Repeated options now issue warnings
    * Special characters in username, password and other values must be url encoded
    * Unsupported connection string options now issue warnings
    * Boolean values can now be represented as true/yes/y/t/1 and false/no/n/f/0.
    * Case is now preserved in Unix domain paths.
  * New function mongoc_cursor_error_document provides access to server's error
    reply if a query or command fails.
  * New function mongoc_write_concern_is_default determines whether any write
    concern options have been set, and mongoc_read_concern_is_default checks if
    read concern options are set.
  * mongoc_gridfs_find_one_with_opts optimized to use limit 1.

Thanks to everyone who contributed to the development of this release.

  * Hannes Magnusson
  * A. Jesse Jiryu Davis
  * David Golden
  * Jeremy Mikola
  * Bernard Spil
  * Aleksander Melnikov
  * Adam Seering
  * Remi Collet

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.6.0
====================

It is my pleasure to announce mongo-c-driver 1.6.0.

New features and bug fixes:

  * Enterprise authentication on Windows now uses the native GSSAPI library;
    Cyrus SASL is no longer required for enterprise auth on Windows.
  * BSON documents are more thoroughly validated before insert or update.
  * New function mongoc_uri_set_mechanism_properties to replace all the
    authMechanismProperties on an existing URI.
  * mongoc_uri_get_mechanism_properties asserts its inputs are not NULL.
  * For consistency with other MongoDB drivers, mongoc_collection_save is
    deprecated in favor of mongoc_collection_insert or mongoc_collection_update.
  * The driver is now built and continuously tested with MinGW-W64 on Windows.
  * Experimental support for HPUX.
  * The correct operation ids are now passed to Command Monitoring callbacks.
  * Fix a crash if the driver couldn't connect to the server to create an index.
  * The documentation is ported from Mallard XML to ReStructured Text, the
    HTML documentation is restyled, and numerous man page syntax errors fixed.
  * Getter functions for options in mongoc_find_and_modify_opts_t:
    * mongoc_find_and_modify_opts_get_bypass_document_validation
    * mongoc_find_and_modify_opts_get_fields
    * mongoc_find_and_modify_opts_get_flags
    * mongoc_find_and_modify_opts_get_max_time_ms
    * mongoc_find_and_modify_opts_get_sort
    * mongoc_find_and_modify_opts_get_update
  * All public functions now have the __cdecl calling convention on Windows.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Aleksander Melnikov
  * Jeroen Ooms
  * Brian McCarthy
  * Jonathan Wang
  * Peter Beckman
  * Remi Collet
  * Rockford Wei
  * Alexey Ponomarev
  * Christopher Wang
  * David Golden
  * Jeremy Mikola

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.5.5
====================

It is my pleasure to announce mongo-c-driver 1.5.5. This release fixes bugs
parsing the localThresholdMS option from the MongoDB URI, and a crash in
mongoc_cursor_destroy if "query" or "filter" are invalid. Thanks to Jeremy
Mikola.

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.5.4
====================

It is my pleasure to announce mongo-c-driver 1.5.4. This release fixes an error
in cursor iteration when a readConcern is set. Thanks to Jeremy Mikola and
Hannes Magnusson.

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.5.3
====================

This release fixes a bug that prevented connecting to IPv4-only MongoDB servers
by hostname.

https://jira.mongodb.org/browse/CDRIVER-1988

The driver has reverted to its 1.5.1 behavior: it connects to MongoDB over IPv6
if given an IPv6 connection string like "mongodb://[::1]", and requires an IPv4
connection when given a hostname like "mongodb://localhost".

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.5.2
====================

It is my pleasure to announce mongo-c-driver 1.5.2.

Thanks to everyone who contributed to the development of this release.

New bug fixes:
  * CDRIVER-1975 allow mixed $ and non-$ query ops.
  * CDRIVER-1972 Support for ipv6 hostnames.
  * CDRIVER-1971 Missing exports of mongoc_gridfs_file_set_*() functions.
  * CDRIVER-1970 update define constants for "find" opts to be unique.
  * CDRIVER-1964 Windows CA stores should be opened with read-only flag.

Thanks to everyone who contributed to the development of this release.

  * Hannes Magnusson
  * A. Jesse Jiryu Davis
  * Alexey Ponomarev
  * Peter Beckman
  * Rockford Wei

Peace,

    Hannes Magnusson


mongo-c-driver 1.5.1
====================

It is my pleasure to announce mongo-c-driver 1.5.1. This is a bugfix release:

  * Fix SEGFAULT with performance counters on NUMA (thanks to Jonathan Wang).
  * Prevent rare assertion error in mongoc_cluster_stream_for_server.
  * Improve error messages from auth failure.
  * Escape quotes when appending CFLAGS to handshake metadata.
  * Fix OpenSSL header lookups in non-default paths.
  * Fix build failure with LibreSSL.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Jeroen Ooms
  * Jonathan Wang

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.5.0
====================

It is my pleasure to announce mongo-c-driver 1.5.0.

New features and bug fixes:
  * MongoDB 3.4 Support
    * New URI and read preference option, "maxStalenessSeconds"
    * MongoDB Handshake
    * writeConcern and readConcern enhancements
    * Collation allows users to specify language-specific rules for string
      comparison when sorting documents. See the code examples for
      mongoc_client_read_command_with_opts, mongoc_collection_count_with_opts,
      mongoc_collection_find_with_opts, and mongoc_index_opt_t, as well as the
      "Setting Collation Order" section of the "Bulk Write Operations" guide.
  * mongoc_collection_count_with_opts uses the collection's read preference if
    none is passed in
  * Improved TLS support
    * Fixed LibreSSL (libssl) support
    * Added LibreSSL (libtls) support
    * Fixed Secure Channel build on VS 2010
    * OpenSSL now supports SNI (all others already do)
  * Additional features for Application Performance Monitoring:
    * mongoc_topology_description_has_writable_server
    * mongoc_topology_description_has_readable_server
  * New functions accept flexible options as a BSON document:
    * mongoc_collection_find_with_opts
    * mongoc_client_read_command_with_opts
    * mongoc_client_write_command_with_opts
    * mongoc_client_read_write_command_with_opts
    * mongoc_database_read_command_with_opts
    * mongoc_database_write_command_with_opts
    * mongoc_database_read_write_command_with_opts
    * mongoc_collection_read_command_with_opts
    * mongoc_collection_write_command_with_opts
    * mongoc_collection_read_write_command_with_opts
    * mongoc_gridfs_find_with_opts
    * mongoc_gridfs_find_one_with_opts
  * mongoc_collection_find is now deprecated in favor of
    mongoc_collection_find_with_opts.
  * New helper function to include read concern in one of the above function's
    options parameter: mongoc_read_concern_append.
  * mongoc_client_command no longer applies the client's read preference and
    read concern by default. Same change for mongoc_database_command and
    mongoc_collection_command.
  * mongoc_collection_count_with_opts now applies the collection's read
    preference if no read preference is provided
  * mongoc_collection_create_index and mongoc_collection_drop_index now apply
    the collection's write concern.
  * connectTimeoutMS timer now begins after DNS resolution, and resets
    for each interface attempted (e.g., if the driver first tries IPv6,
    then IPv4).
  * New error code MONGOC_ERROR_DUPLICATE_KEY.
  * mongoc_collection_find no longer treats the "filter" key specially in
    queries - querying for a document with a key named "filter" is the same
    now as any other key.
  * The server description parameter to the following functions is "const":
    * mongoc_server_description_host
    * mongoc_server_description_id
    * mongoc_server_description_ismaster
    * mongoc_server_description_round_trip_time
    * mongoc_server_description_type
  * Exported symbols are no longer declared in separate export files.
    This could break ABI with applications using clang, which previously
    exported symbols from the internal private ABI.
  * mongoc no longer crashes when multi roundtrip bulk operation fails.
  * Added support for the new readConcernLevel "linearizable".
  * Clients now check for misformatted "readPreferenceTags" in URI.
  * New CMake option ENABLE_TRACING allows debug output, which before had only
    been available with "configure --enable-tracing".
  * Bugfix: "PossiblePrimary"-type replicas could be selected for reads
  * Bugfixes: The random number generator used to select servers is now properly
    seeded, and secondary queries are now properly distributed according to
    localThresholdMS, not just to the lowest-latency secondary.
  * mongoc_collection_insert, mongoc_collection_update, mongoc_collection_remove
    consistently use domain MONGOC_ERROR_BSON, code MONGOC_ERROR_BSON_INVALID
    if passed oversized BSON, and MONGOC_ERROR_COLLECTION for other errors.
    mongoc_bulk_operation_execute continues to use MONGOC_ERROR_COMMAND for
    all errors.
  * If mongoc_client_pool_t fails to start its scanner thread in the background,
    it logs and aborts instead of silently continuing, then failing to connect.
  * The driver now updates its view of the whole topology with information from
    each new connection handshake.
  * mongoc_client_set_apm_callbacks can be used repeatedly to change or clear
    the list of monitoring callbacks.
  * Improved error reporting when the driver fails to reach the server.

Deprecations:
  * mongoc_collection_find is deprecated for mongoc_collection_find_with_opts.

Removed configure flags:
  * --enable-experimental has been removed. All previously experimental
    features are now always on.
  * The configure option "--enable-hardening" had had no effect. It is removed
    in favor of system-wide compiler configuration.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Fiona Rowan
  * Ian Boros
  * Remi Collet
  * Brian McCarthy
  * Jeroen Ooms
  * J. Rassi
  * Christoph Schwarz
  * Alexey Vorobeyev

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.4.2
====================

It is my pleasure to announce mongo-c-driver 1.4.2. This release fixes bugs in
"minPoolSize" logic, see CDRIVER-1558 for details.

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.4.1
====================

It is my pleasure to announce mongo-c-driver 1.4.1. This is a bugfix release:

  * mongoc_client_get_server_descriptions could return a list including NULLs
  * Tailable cursors on MongoDB 3.2 only worked with MONGOC_QUERY_AWAIT_DATA
  * Spurious warnings with MONGOC_DISABLE_SHM

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.4.0
====================

It is my pleasure to announce the release of mongo-c-driver 1.4.0.

TLS
---

The driver can now use the native TLS and crypto functions included in macOS
and Windows. OpenSSL is no longer required for TLS or authentication on Mac or
Windows. By default, OpenSSL is used if available, the default will switch in
version 2.0 to prefer native TLS.

For native TLS on Mac:

  ./configure --enable-ssl=darwin

For Windows:

  cmake "-DENABLE_SSL=WINDOWS" -G "Visual Studio 10 Win64" "-DCMAKE_INSTALL_PREFIX=C:\mongo-c-driver"

All of the TLS implementations now load the native default certificate store,
with OpenSSL on Windows falling back on the Windows native certificate store if
no other can be found.

The "ca_dir" field on mongoc_ssl_opt_t is only supported by OpenSSL. All other
fields, including "pem_file", are supported by all implementations.

A new field, "allow_invalid_hostname", has been added to mongoc_ssl_opt_t and is
preferred over the existing "allow_invalid_certificate" to disable hostname
verification.

The driver now supports the latest OpenSSL 1.1 in addition to past versions.

Application Performance Monitoring
----------------------------------

The driver implements the MongoDB Command Monitoring Spec. Applications can
record the duration and other details of every operation the driver performs on
the server. See "Introduction to Application Performance Monitoring" in the
docs.

Error API
---------

New functions mongoc_client_set_error_api and mongoc_client_pool_set_error_api
allow applications to distinguish client and server errors. See the "Error
Reporting" doc.

Unacknowledged Write Results
----------------------------

Unacknowledged writes (writes whose mongoc_write_concern_t "w" value is zero)
now reply with an empty document instead of one with nInserted: 0, nUpdated: 0,
and so on.

Command functions now ignore the read preferences set on a client, database,
or collection. Instead, they use the mongoc_read_prefs_t passed in explicitly,
or default to "primary". This change was made to bring them in line with the
Server Selection Spec. These are the affected functions:

  * mongoc_client_command
  * mongoc_client_command_simple
  * mongoc_database_command
  * mongoc_database_command_simple
  * mongoc_collection_command
  * mongoc_collection_command_simple

On the other hand, the following command-specific helper functions now use the
collection's read preference:

  * mongoc_collection_count
  * mongoc_collection_stats

New functions to send maxTimeMS or any arbitrary options with findAndModify:

  * mongoc_find_and_modify_opts_set_max_time_ms
  * mongoc_find_and_modify_opts_append

New function to include a write concern with a generic command function
like mongoc_client_command_simple:

  * mongoc_write_concern_append

Public API For Higher-Level Drivers
-----------------------------------

New functions support language drivers (specifically the PHP and HHVM drivers)
using only the libmongoc public API:

  * mongoc_bulk_operation_get_hint
  * mongoc_client_command_simple_with_server_id
  * mongoc_client_get_server_description
  * mongoc_client_get_server_description_by_id
  * mongoc_client_get_server_descriptions
  * mongoc_client_select_server
  * mongoc_cursor_get_limit
  * mongoc_cursor_new_from_command_reply
  * mongoc_cursor_set_hint
  * mongoc_cursor_set_limit
  * mongoc_log_trace_disable
  * mongoc_log_trace_enable
  * mongoc_server_description_ismaster
  * mongoc_server_description_round_trip_time
  * mongoc_server_description_type
  * mongoc_server_descriptions_destroy_all
  * mongoc_uri_get_option_as_bool
  * mongoc_uri_get_option_as_int32
  * mongoc_uri_get_option_as_utf8
  * mongoc_uri_option_is_bool
  * mongoc_uri_option_is_int32
  * mongoc_uri_option_is_utf8
  * mongoc_uri_set_auth_source
  * mongoc_uri_set_database
  * mongoc_uri_set_option_as_bool
  * mongoc_uri_set_option_as_int32
  * mongoc_uri_set_option_as_utf8
  * mongoc_uri_set_password
  * mongoc_uri_set_read_concern
  * mongoc_uri_set_read_prefs_t
  * mongoc_uri_set_username
  * mongoc_uri_set_write_concern
  * mongoc_write_concern_is_acknowledged
  * mongoc_write_concern_is_valid
  * mongoc_write_concern_journal_is_set

Now that these public APIs are available, the PHP drivers no longer define the
MONGOC_I_AM_A_DRIVER preprocessor symbol to access private APIs. The symbol is
removed from C Driver headers, and libmongoc-priv.so is no longer installed.

Other Features
--------------

  * New connection string option "localThresholdMS".
  * zSeries and POWER8 platform support.
  * Performance enhancements, reduce allocation and copying in command code.
  * All man page names now begin with "mongoc_" to avoid install conflicts.
  * New function mongoc_gridfs_file_set_id.

Deprecations
------------

Automatically calling mongoc_init and mongoc_cleanup is a GCC-specific feature
that is now deprecated, and will be removed in version 2. The driver should be
built with:

./configure --disable-automatic-init-and-cleanup

Or:

  cmake "-DENABLE_AUTOMATIC_INIT_AND_CLEANUP=OFF" -G "Visual Studio 10 Win64" "-DCMAKE_INSTALL_PREFIX=C:\mongo-c-driver"

In this configuration, applications must explicitly init and cleanup libmongoc.

Deprecated functions:

  * mongoc_write_concern_get_fsync
  * mongoc_write_concern_set_fsync

Notable Bug Fixes
-----------------

  * Logic bugs using tag sets to select replica set members with complex configs
  * mongoc_client_get_database_names no longer filters out a replica set
    member's "local" database.
  * mongoc_client_get_gridfs now ensures the proper indexes on the files and
    chunks collections.
  * SecondaryPreferred fails if primary matches tags but secondaries don't.
  * mongoc_collection_find_and_modify_with_opts can return true on
    writeConcernError.
  * mongoc_collection_validate doesn't always init "reply".
  * The strings referred to by mongoc_ssl_opt_t, like pem_file and ca_file, are
    now copied into the client or client pool by mongoc_client_set_ssl_opts or
    mongoc_client_pool_set_ssl_opts, and need not be kept valid afterward.
  * mongoc_collection_count_with_opts ignored flags and read_prefs.
  * minPoolSize of 0 should mean "no minimum".
  * mongoc_database_create_collection should always use the primary.
  * The GSSAPI properties SERVICE_NAME and CANONICALIZE_HOST_NAME are now
    properly parsed from the URI, see the "Authentication" doc for details.
  * Comprehensive compatibility with various C standards and compilers.

Acknowledgements
----------------

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Ian Boros
  * Fiona Rowan
  * Jeremy Mikola
  * Christoph Schwarz
  * Mike Lloyd
  * Remi Collet
  * Jean-Bernard Jansen
  * David Hatch
  * Derick Rethans
  * Brian Samek

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.3.5
====================

It is my pleasure to announce mongo-c-driver 1.3.5. This release fixes a crash
in mongoc_cleanup when an allocator had been set with bson_mem_set_vtable, and
introduces a configure option MONGOC_NO_AUTOMATIC_GLOBALS which prevents code
built with GCC from automatically calling mongoc_init and mongoc_cleanup when
your code does not.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.3.4
====================

It is my pleasure to announce the MongoDB C Driver 1.3.4. This release fixes a
security vulnerability: when a mongoc_client_t uses SSL and is disconnected, it
failed to re-verify the server certificate after reconnecting. This flaw affects
single clients, not pooled ones.

Thanks to everyone who contributed to the development of this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Remi Collet

Peace,

    A. Jesse Jiryu Davis


mongo-c-driver 1.3.3
====================

It is my pleasure to announce MongoDB C Driver 1.3.3. This fixes a bug where
a slightly-oversized bulk write operation was not split into batches; instead,
it was sent whole to the server, which rejected it.

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.3.2
====================

It is my pleasure to announce MongoDB C Driver 1.3.2. This is a bugfix release:

  * A socket is properly discarded after a network error from a command.
  * mongoc_database_get_collection now copies the database's read preferences,
    read concern, and write concern, instead of copying the client's.
  * mongoc_cursor_t's private struct now allows a negative limit.

Thanks to everyone who contributed to this release.

  * A. Jesse Jiryu Davis
  * Jeremy Mikola
  * Hannes Magnusson

Peace,

  A. Jesse Jiryu Davis



mongo-c-driver 1.3.1
====================

It is my pleasure to announce MongoDB C Driver 1.3.1. This is a bugfix release:

  * mongoc_client_get_gridfs now copies the client's read preferences, read
    concern, and write concern to the newly created mongoc_gridfs_t. Before
    this fix, GridFS operations were always executed with the default config:
    data was read from the primary, with the read concern level "local", and
    written with write concern "acknowledged". Now, if you have configured any
    of these options on the mongoc_client_t, they are respected by the
    mongoc_gridfs_t.
  * CMakeLists.txt now includes and installs the pkg-config files.

Thanks to everyone who contributed to this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Christopher Wang
  * Jean-Bernard Jansen
  * Jeremy Mikola
  * Jeroen Ooms

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.3.0
====================

It is my pleasure to announce to you the release of the MongoDB C Driver 1.3.0.

Changes since the release candidate 1.3.0-rc0:

  * Fix a cursor bug introduced on big-endian platforms in 1.3.0-beta0.
  * Improve documentation for mongoc_host_list_t.
  * Move private mongoc_host_list_t functions from public header.
  * Refactor the build system to declare library version in one place.

All new features and changes since the previous stable release, 1.2.1:

  * If the driver is compiled without SSL support but a URI with "ssl=true"
    is passed to mongoc_client_new, mongoc_client_new_from_uri, or
    mongoc_client_pool_new, the function logs an error and returns NULL. Before,
    the driver would attempt a non-SSL connection.
  * mongoc_collection_find_and_modify will now apply the mongoc_collection_t's
    write_concern_t when talking to MongoDB 3.2.
  * Support for MongoDB 3.2's "readConcern" feature for queries, counts, and
    aggregations. The option "readConcernLevel" is now accepted in the MongoDB
    URI. New struct mongoc_read_concern_t, and functions operating on it:
   - mongoc_client_get_read_concern
   - mongoc_client_set_read_concern
   - mongoc_database_get_read_concern
   - mongoc_database_set_read_concern
   - mongoc_collection_get_read_concern
   - mongoc_collection_set_read_concern
   - mongoc_read_concern_copy
   - mongoc_read_concern_destroy
   - mongoc_read_concern_get_level
   - mongoc_read_concern_new
   - mongoc_read_concern_set_level
   - mongoc_uri_get_read_concern
  * Support for MongoDB 3.2's "bypassDocumentValidation" option for writes.
  * New struct mongoc_bulk_write_flags_t and related functions:
   - mongoc_bulk_operation_set_bypass_document_validation
  * New struct mongoc_find_and_modify_opts_t and related functions:
   - mongoc_find_and_modify_opts_new
   - mongoc_find_and_modify_opts_destroy
   - mongoc_find_and_modify_opts_set_sort
   - mongoc_find_and_modify_opts_set_update
   - mongoc_find_and_modify_opts_set_fields
   - mongoc_find_and_modify_opts_set_flags
   - mongoc_find_and_modify_opts_set_bypass_document_validation
   - mongoc_collection_find_and_modify_with_opts
  * New functions to copy database and collection handles:
   - mongoc_collection_copy
   - mongoc_database_copy
  * Support for MongoDB 3.2 wire protocol: use commands in place of OP_QUERY,
    OP_GETMORE, and OP_KILLCURSORS messages.
  * To explain a query plan with MongoDB 3.2, you must now call the "explain"
    command, instead of including the "$explain" key in a mongoc_collection_find
    query. See the mongoc_collection_find documentation page for details.
  * Configurable wait time on tailable cursors with MongoDB 3.2:
   - mongoc_cursor_get_max_await_time_ms
   - mongoc_cursor_set_max_await_time_ms
  * Use electionId to detect a stale replica set primary during a network split.
  * Disconnect from replica set members whose "me" field does not match the
    connection address.
  * The client side matching feature, mongoc_matcher_t and related functions,
    are deprecated and scheduled for removal in version 2.0.
  * New CMake options ENABLE_SSL, ENABLE_SASL, ENABLE_TESTS, and ENABLE_EXAMPLES.
  * Use constant-time comparison when verifying credentials.
  * Combine environment's CFLAGS with configure options when building.
  * Improved man page output and "whatis" entries.

There are extensive bugfixes and improvements in GridFS since 1.2.1, including:

  * Handle seeking, reading, and writing past the end of a GridFS file.
  * If a GridFS chunk is missing, mongoc_gridfs_file_readv sets file->error to
    domain MONGOC_ERROR_GRIDFS and a new code MONGOC_ERROR_GRIDFS_CHUNK_MISSING.
  * Optimization for long seeks forward with mongoc_gridfs_file_seek.

Other fixes since 1.2.1:

  * Memory leaks in mongoc_database_has_collection and mongoc_cursor_next.
  * Report writeConcern failures from findAndModify and from legacy writes.
  * Memory leak in mongoc_database_find_collections.
  * Set OP_QUERY's nToReturn from the provided limit.
  * Fix compiler warnings and errors, especially with Visual Studio 2015,
    GCC 4.8, and IBM XL C.
  * Bugs and typos in tutorial examples.

Thanks to everyone who contributed to this release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Kyle Suarez
  * Jose Sebastian Battig
  * Matt Cotter
  * Claudio Canella
  * alexeyvo
  * Christopher Wang
  * Flavio Medeiros
  * Iago Rubio
  * Jeremy Mikola
  * Victor Leschuk
  * Jason Carey

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.3.0-rc0
========================

It is my pleasure to announce to you the first release candidate of MongoDB C
driver 1.3.0. It includes additive ABI changes and bugfixes, and support for
the upcoming MongoDB 3.2. It is compatible with MongoDB 2.4 and later.

New features and changes since 1.3.0-beta0:

  * If the driver is compiled without SSL support but a URI with "ssl=true"
    is passed to mongoc_client_new, mongoc_client_new_from_uri, or
    mongoc_client_pool_new, the function logs an error and returns NULL. Before,
    the driver would attempt a non-SSL connection.
  * New functions to copy database and collection handles:
   - mongoc_collection_copy
   - mongoc_database_copy
  * If a GridFS chunk is missing, mongoc_gridfs_file_readv sets file->error to
    domain MONGOC_ERROR_GRIDFS and a new code MONGOC_ERROR_GRIDFS_CHUNK_MISSING.
  * Use electionId to detect a stale replica set primary during a network split.
  * Disconnect from replica set members whose "me" field does not match the
    connection address.
  * The client side matching feature, mongoc_matcher_t and related functions,
    are deprecated and scheduled for removal in version 2.0.
  * New CMake options ENABLE_SSL, ENABLE_SASL, ENABLE_TESTS, and ENABLE_EXAMPLES.
  * The build system is refactored to declare the current version and latest
    release in one place.

Other fixes:

  * Memory leaks in mongoc_database_has_collection and mongoc_cursor_next.
  * Report writeConcern failures from findAndModify and from legacy writes.

Thanks to everyone who contributed to this release candidate.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Matt Cotter
  * Claudio Canella
  * Victor Leschuk
  * Flavio Medeiros
  * Christopher Wang

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.3.0-beta0
==========================

It is my pleasure to announce to you the beta of MongoDB C driver 1.3.0.
This beta includes additive ABI changes and bugfixes, and support for
the upcoming MongoDB 3.2. It is compatible with MongoDB 2.4 and later.

New features and changes:

  * mongoc_collection_find_and_modify will now apply the mongoc_collection_t's
    write_concern_t when talking to MongoDB 3.2.
  * Support for MongoDB 3.2's "readConcern" feature for queries, counts, and
    aggregations. The option "readConcernLevel" is now accepted in the MongoDB
    URI. New struct mongoc_read_concern_t, and functions operating on it:
   - mongoc_client_get_read_concern
   - mongoc_client_set_read_concern
   - mongoc_database_get_read_concern
   - mongoc_database_set_read_concern
   - mongoc_collection_get_read_concern
   - mongoc_collection_set_read_concern
   - mongoc_read_concern_copy
   - mongoc_read_concern_destroy
   - mongoc_read_concern_get_level
   - mongoc_read_concern_new
   - mongoc_read_concern_set_level
   - mongoc_uri_get_read_concern
  * Support for MongoDB 3.2's "bypassDocumentValidation" option for writes.
  * New struct mongoc_bulk_write_flags_t and related functions:
   - mongoc_bulk_operation_set_bypass_document_validation
  * New struct mongoc_find_and_modify_opts_t and related functions:
   - mongoc_find_and_modify_opts_new
   - mongoc_find_and_modify_opts_destroy
   - mongoc_find_and_modify_opts_set_sort
   - mongoc_find_and_modify_opts_set_update
   - mongoc_find_and_modify_opts_set_fields
   - mongoc_find_and_modify_opts_set_flags
   - mongoc_find_and_modify_opts_set_bypass_document_validation
   - mongoc_collection_find_and_modify_with_opts
  * Configurable wait time on tailable cursors with MongoDB 3.2:
   - mongoc_cursor_get_max_await_time_ms
   - mongoc_cursor_set_max_await_time_ms
  * Support for MongoDB 3.2 wire protocol: use commands in place of OP_QUERY,
    OP_GETMORE, and OP_KILLCURSORS messages.
  * To explain a query plan with MongoDB 3.2, you must now call the "explain"
    command, instead of including the "$explain" key in a mongoc_collection_find
    query. See the mongoc_collection_find documentation page for details.
  * Use constant-time comparison when verifying credentials.
  * Combine environment's CFLAGS with configure options when building.
  * Improved man page output and "whatis" entries.

Extensive bugfixes and improvements in GridFS, including:

  * Handle seeking, reading, and writing past the end of a GridFS file.
  * Optimization for long seeks forward with mongoc_gridfs_file_seek.

Other fixes:

  * Memory leak in mongoc_database_find_collections.
  * Set OP_QUERY's nToReturn from the provided limit.
  * Fix compiler warnings and errors, especially with Visual Studio 2015,
    GCC 4.8, and IBM XL C.
  * Bugs and typos in tutorial examples

Thanks to everyone who contributed to this beta release.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Kyle Suarez
  * Jose Sebastian Battig
  * Jeremy Mikola
  * Iago Rubio
  * Matt Cotter
  * alexeyvo

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.2.2
====================

It is my pleasure to announce to you the MongoDB C driver 1.2.2.

This release fixes a rare bug where the driver can direct reads to hidden
secondaries unintentionally. It also includes fixes and improvements to the
build system.

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.2.1
====================

It is my pleasure to announce to you the MongoDB C driver 1.2.1.

This release includes critical bugfixes for SSL connections with
mongoc_client_pool_t, and for Unix domain socket connections.

The documentation is updated for a change introduced in version 1.2.0:
mongoc_client_set_ssl_opts and mongoc_client_pool_set_ssl_opts now configure
the driver to require an SSL connection to the server, even if "ssl=true" is
omitted from the MongoDB URI. Before, SSL options were ignored unless
"ssl=true" was included in the URI.

The build instructions are improved, including the steps to build with OpenSSL
on OS X El Capitan. Build errors and warnings are fixed for clang in gnu99
mode and MinGW.

Thanks to everyone who contributed to this version of libmongoc.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Tamas Nagy

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.2.0
====================

It is my pleasure to announce to you the MongoDB C driver 1.2.0.

This is a stable release with additive ABI changes and bugfixes. It is
compatible with MongoDB version 2.4 and later.

The following notes summarize changes since the previous stable release,
1.1.11, including changes in the 1.2.0 betas and release candidate.

This version rewrites mongoc_client_t's internals to match two important new
specs for MongoDB drivers: the Server Discovery And Monitoring Spec and the
Server Selection Spec. The rewritten client has many advantages:

  * All replica set members or mongos servers are discovered and periodically
    checked in parallel. The driver's performance is dramatically better and
    more predictable with multi-server deployments, or with a flaky network,
    or when some servers are slow or down.
  * Clients from the same mongoc_client_pool_t share a background thread that
    discovers and monitors all servers in parallel.
  * Unnecessary round trips for server checks and pings are eliminated.
  * Behavior is documented in the specs, and consistent with other drivers,
    even in complex or unusual scenarios.
  * The URI's "replicaSet" option is enforced: the driver now refuses to connect
    to a server unless it is a member of a replica set with the correct setName.
  * Many race conditions related to changing deployment conditions are fixed.

To conform to the new specs, the client now accepts these options in the
MongoDB URI; see the mongoc_uri_t documentation for details:

  * heartbeatFrequencyMS
  * serverSelectionTimeoutMS
  * serverSelectionTryOnce
  * socketCheckIntervalMS

Other features:

  * All timeouts that can be configured in the URI now interpret 0 to mean "use
    the default value for this timeout".
  * The client's read preference can be configured in the URI with the new
    options "readPreference" and "readPreferenceTags"; see the mongoc_uri_t
    documentation.
  * The new mongoc_uri_get_read_prefs_t function retrieves both the read mode
    and tags from a mongoc_uri_t.
  * New accessors mongoc_gridfs_file_get_id, mongoc_client_get_default_database,
    and mongoc_bulk_operation_get_write_concern.
  * Debug tracing can be controlled at runtime with mongoc_log_trace_enable and
    mongoc_log_trace_disable.
  * Set mongoc_client_pool_t's size with mongoc_client_pool_min_size()
    and mongoc_client_pool_max_size().

Other changes:

  * Enable runtime asserts in release build.
  * The libbson submodule's URL now uses the recommended https://, not git://
  * mongoc_client_kill_cursor is now deprecated and will be removed in 2.0.
  * The write concern "w=-1" is documented as obsolete.

These notable bugs have been fixed since 1.1.11:

  * The driver now uses the server's maxWireVersion to avoid an error and
    extra round-trip when executing aggregations on MongoDB 2.4 and older.
  * Much improved reporting of network errors, unavailable servers, and
    authentication failure
  * Off-by-one error in mongoc_gridfs_file_seek with mode SEEK_END
  * The writeConcernErrors field of bulk results is properly formatted.
  * A cursor with a server "hint" sets slaveOkay and / or $readPreference.
  * Destroying an exhaust cursor must close its socket
  * "wtimeoutms" was ignored for write concerns besides "majority".
  * Bulk write operations might fail in mixed-version sharded clusters with
    some pre-2.6 mongos servers.
  * A variety of bugs and incorrect results in mongoc_bulk_operation_execute.
  * Numerous compiler warnings and build failures on various platforms.
  * Copious refinements to the documentation.

Thanks to everyone who contributed to this version of libmongoc.

  * Jason Carey
  * Samantha Ritter
  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Kyle Suarez
  * Jeremy Mikola
  * Remi Collet
  * Jose Sebastian Battig
  * Derick Rethans
  * Yuchen Xie
  * Manuel Schoenlaub
  * Sujan Dutta
  * Lloyd Zhou
  * rubicks
  * Pawel Szczurko
  * Yuval Hager

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.2.0-rc0
========================

It is my pleasure to announce the release candidate of the MongoDB C driver
1.2.0. It includes features and bugfixes developed since 1.2.0-beta1.

Notable bugs fixed:

  * Much improved reporting of network errors, unavailable servers, and
    authentication failure
  * Destroying an exhaust cursor must close its socket
  * Various bugs in server reconnection logic
  * mongoc_collection_aggregate returned invalid cursor after failure
  * Wrong error message after failed network write on Sparc
  * Missing JSON test files in release tarball

Other changes:

  * Enable runtime asserts in release build.
  * mongoc_client_kill_cursor is now deprecated and will be removed in
    version 2.0.

This release candidate also includes all bugfixes from 1.1.11.

Version 1.2.0 final will be a stable release with additive ABI changes and
bugfixes. It is compatible with MongoDB version 2.4 and later.

Thanks to everyone who contributed to this version of libmongoc.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Kyle Suarez
  * rubicks
  * Jose Sebastian Battig
  * Jason Carey
  * Remi Collet
  * Yuval Hager

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.2.0-beta1
==========================

It is my pleasure to announce the second beta release of the MongoDB C driver
1.2.0. It includes features and bugfixes developed since 1.2.0-beta.

New features:

  * Set mongoc_client_pool_t's size with mongoc_client_pool_min_size()
    and mongoc_client_pool_max_size().
  * The write concern "w=-1" is now documented as obsolete.
  * Abundant fixes and additions to the documentation, beyond those in the
    previous beta.

Notable bugs fixed:

  * Crashes and races in several replica set scenarios.
  * The driver now uses the server's maxWireVersion to avoid an error and
    extra round-trip when executing aggregations on MongoDB 2.4 and older.
  * Fixed network error handling in multiple code paths.
  * connectTimeoutMS limits the time the driver can spend reconnecting to
    servers in single-threaded (non-pooled) mode with serverSelectionTryOnce.

Version 1.2.0 final will be a stable release with additive ABI changes and
bugfixes. It is compatible with MongoDB version 2.4 and later.

Thanks to everyone who contributed to this version of libmongoc.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Manuel Schoenlaub
  * Kyle Suarez
  * Remi Collet

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.2.0-beta
=========================

It is my pleasure to announce to you the first beta release of the MongoDB C
driver 1.2.0.

This release is a stable release with additive ABI changes and bugfixes.
It is compatible with MongoDB version 2.4 and later.

Version 1.2.0 rewrites mongoc_client_t's internals to match two important new
specs for MongoDB drivers: the Server Discovery And Monitoring Spec and the
Server Selection Spec. The rewritten client has many advantages:

  * All replica set members or mongoses are discovered and periodically
    checked in parallel. The driver's performance is dramatically better and
    more predictable with multi-server deployments, or with a flaky network,
    or when some servers are slow or down.
  * Clients from the same mongoc_client_pool_t share a background thread that
    discovers and monitors all servers in parallel.
  * Unnecessary round trips for server checks and pings are eliminated.
  * Behavior is documented in the specs, and consistent with other drivers, even
    in complex or unusual scenarios.
  * The URI's "replicaSet" option is enforced: the driver now refuses to connect
    to a server unless it is a member of a replica set with the right setName.
  * Many race conditions related to changing deployment conditions are fixed.

To conform to the new specs, the client now accepts these options in the MongoDB
URI; see the mongoc_uri_t documentation for details:

  * heartbeatFrequencyMS
  * serverSelectionTimeoutMS
  * serverSelectionTryOnce
  * socketCheckIntervalMS

Other features:

  * All timeouts that can be configured in the URI now interpret 0 to mean "use
    the default value for this timeout".
  * The client's read preference can be configured in the URI with the new
    options "readPreference" and "readPreferenceTags", see the mongoc_uri_t
    documentation.
  * The new mongoc_uri_get_read_prefs_t function retrieves both the read mode
    and tags from a mongoc_uri_t.
  * New accessors mongoc_gridfs_file_get_id, mongoc_client_get_default_database,
    and mongoc_bulk_operation_get_write_concern.
  * Debug tracing can be controlled at runtime with mongoc_log_trace_enable and
    mongoc_log_trace_disable.

Notable bugs fixed:

  * "wtimeoutms" was ignored for write concerns besides "majority".
  * Bulk write operations might fail in mixed-version sharded clusters with
    some pre-2.6 mongos servers.
  * Normal operations were logged during startup and could not be silenced.
  * A variety of bugs and incorrect results in mongoc_bulk_operation_execute.
  * Numerous compiler warnings and build failures on various platforms.
  * Copious refinements to the documentation.

Thanks to everyone who contributed to this version of libmongoc.

  * A. Jesse Jiryu Davis
  * Sujan Dutta
  * Jason Carey
  * Hannes Magnusson
  * Jeremy Mikola
  * Derick Rethans
  * Samantha Ritter
  * Yuchen Xie
  * Lloyd Zhou

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.1.11
=====================

It is my pleasure to announce to you the MongoDB C driver 1.1.11.

This is a patch release with bug fixes:

  * Undetected network errors when sending messages to the server
  * Off-by-one error in mongoc_gridfs_file_seek with mode SEEK_END
  * Memory leak parsing a URI that contains an invalid option
  * The libbson submodule's URL now uses the recommended https://, not git://

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * A. Jesse Jiryu Davis
  * Hannes Magnusson
  * Jason Carey
  * Jose Sebastian Battig
  * rubicks

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.1.10
=====================

It is my pleasure to announce to you the MongoDB C driver 1.1.10.

This is a patch release with bug fixes:

  * Occasional crash reconnecting to replica set.
  * Queries sent to recovering replica set members.
  * Memory leak when calling ismaster on replica set members.

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * A. Jesse Jiryu Davis
  * Daniil Zaitsev
  * Jason Carey
  * Jeremy Mikola

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.1.9
====================

It is my pleasure to announce to you the MongoDB C driver 1.1.9.

This release fixes a common crash in 1.1.8, which itself was introduced while
fixing a rare crash in 1.1.7. For further details:

https://jira.mongodb.org/browse/CDRIVER-721
https://jira.mongodb.org/browse/CDRIVER-695

Thanks to everyone who contributed to the development of this point release for
libmongoc.

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.1.8
====================

UPDATE: 1.1.8 suffered a severe new bug so I removed the release from GitHub:

https://jira.mongodb.org/browse/CDRIVER-721

This is a patch release with bug fixes:

  * Crash freeing client after a replica set auth error.
  * Compile error strict C89 mode.

mongo-c-driver 1.1.7
====================

It is my pleasure to announce to you the 1.1.7 release of the MongoDB C driver.

This is a patch release with bug fixes:

  * Thread-safe use of Cyrus SASL library.
  * Experimental support for building with CMake and SASL.
  * Faster reconnection to replica set with some hosts down.
  * Crash iterating a cursor after reconnecting to a replica set.
  * Unchecked errors decoding invalid UTF-8 in MongoDB URIs.
  * Fix error reporting from mongoc_client_get_database_names.

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * A. Jesse Jiryu Davis
  * Jason Carey
  * Hannes Magnusson

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.1.6
====================

It is my pleasure to announce to you the 1.1.6 release of the MongoDB C driver.

This is a patch release with performance enhancements and bug fixes:

  * mongoc_bulk_operation_execute now coalesces consecutive update operations
    into a single message to a MongoDB 2.6+ server, yielding huge performance
    gains. Same for remove operations. (Inserts were always coalesced.)
  * Large numbers of insert operations are now properly batched according to
    number of documents and total data size.
  * GSSAPI / Kerberos auth now works.
  * The driver no longer tries three times in vain to reconnect to a primary,
    so socketTimeoutMS and connectTimeoutMS now behave *closer* to what you
    expect for replica sets with down members. A full fix awaits 1.2.0.

I snuck in a feature:

  * mongoc_matcher_t now supports basic subdocument and array matching

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * A. Jesse Jiryu Davis
  * Jason Carey
  * Kai Mast
  * Matt Cotter

Peace,

  A. Jesse Jiryu Davis


mongo-c-driver 1.1.5
====================

It is my pleasure to announce to you the 1.1.5 release of the MongoDB C driver.

This is a patch release with performance enhancements and bug fixes:

  * The fsync and j write concern flags now imply acknowledged writes
  * Prevent using fsync or j with conflicting w=0 write concern
  * Obey socket timeout consistently in TLS/SSL mode
  * Return an error promptly after a network hangup in TLS mode
  * Prevent crash using SSL in FIPS mode
  * Always return NULL from mongoc_database_get_collection_names on error
  * Fix version check for GCC 5 and future versions of Clang
  * Fix warnings and errors building on various platforms
  * Add configure flag to enable/disable shared memory performance counters
  * Minor docs improvements and fix links from C Driver docs to Libbson docs

With this release, Libbson abandons the convention that odd-numbered patch
versions indicate unstable releases. We switch to simple semantic versioning:
1.1.5 is a stable release with bug fixes since 1.1.4. During subsequent
development the version will be "1.1.6-dev".

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * A. Jesse Jiryu Davis
  * Christian Hergert
  * Jason Carey
  * Jeremy Mikola
  * Jeroen Ooms
  * Hannes Magnusson

Enjoy!

-- A. Jesse Jiryu Davis


mongo-c-driver 1.1.4
====================

It is my pleasure to announce to you the 1.1.4 release of the MongoDB C driver.

This release is a stable release with performance enhancements and bugfixes.

Changes include:
  * Fixed client pool concurrency issues
  * Fixed some scenarios where replica sets would fail to reconnect on primary
    step down.
  * Improved write concern handling
  * Validate port number in URI
  * Various other fixes

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * Jason Carey
  * Andrew Clayton
  * A. Jesse Jiryu Davis
  * Jeremy Mikola

Enjoy!

-- Jason Carey


mongo-c-driver 1.1.2
====================

It is my pleasure to announce to you the 1.1.2 release of the MongoDB C driver.

This release is a stable release with performance enhancements and bugfixes.

Changes include:
  * Process connectTimeoutMS cast insensitively
  * Addition of missing trace macros
  * Improvement of internal error messages
  * Fix a segfault in OpenSSL cleanup routines
  * Fix for IPv6 support for replica sets
  * Coalesce small vectorized TLS writes
  * MinGW fixups
  * Fix for a memory leak in get_database_names()
  * Fixes for patching write concern through the bulk api
  * Fix to normalize hostnames in uri parsing
  * Fix for managing connections in the client pool
  * Various other fixes

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * Andrew Clayton
  * Denis Gladkikh
  * Hannes Magnusson
  * Jason Carey
  * Jeremy Mikola
  * mschoenlaub
  * Samantha Ritter
  * Tyler Brock

Enjoy!

-- Jason Carey


mongo-c-driver 1.1.0
====================

It is my pleasure to announce to you the 1.1.0 release of the MongoDB C driver.

This release is a stable release with additive ABI changes and bugfixes.

The below changes include some carried over from RC0.

Changes include:
  * RC0
   * ABI versioning for 1.1 versus 1.0 symbols
   * additional geo index options
   * authMechanismProperties in URI
   * fixes for OS X Yosemite
   * removal of replica set member limit
   * SCRAM-SHA-1 SASL mechanism
   * updated dependency on libbson 1.1 abi
   * validation for bulk insert
   * various memory leak fixes
  * Fixes to documentation typos
  * "How to Ask For Help" in the README
  * Removed dependency on sasl for PLAIN authentication
  * Use provided username, if available, for X.509 auth
  * Fixed WriteConcern error reporting for some writes
  * Check for closed sockets before attempting RPCs
  * Fixes for gridfs file seek
  * Fixes for mongoc_cursor_clone()
  * Fixes for unix domain socket support
  * Fixes for polling on win32
  * Improved warnings on failure to connect
  * Addition of wired tiger options
  * Fixes for examples

Additions to the ABI include:
  * support for extra option in count
   - mongoc_collection_count_with_opts
  * additional index options
   - mongoc_index_opt_geo_get_default
   - mongoc_index_opt_geo_init
   - mongoc_index_opt_wt_get_default
   - mongoc_index_opt_wt_init
  * rand interface to seed and verify the strong random number generation needed
    by some auth mechanisms
   - mongoc_rand_seed
   - mongoc_rand_add
   - mongoc_rand_status
  * URI additions to support more complicated auth credentials
   - mongoc_uri_get_credentials
   - mongoc_uri_get_mechanism_properties
  * Support for cursor returning metadata crud operations
   - mongoc_client_find_databases
   - mongoc_collection_find_indexes
   - mongoc_database_find_collections
  * Kill cursor support
   - mongoc_client_kill_cursor
  * Various get/setters on cursor
   - mongoc_cursor_get_batch_size
   - mongoc_cursor_get_id
   - mongoc_cursor_set_batch_size
  * More socket/stream options
   - mongoc_socket_check_closed
   - mongoc_socket_inet_ntop
   - mongoc_stream_check_closed
   - mongoc_stream_write

Additional Notes:
    Existing complex index names may contain a zero instead of a type due to
a bug in mongoc_collection_keys_to_index_string. As a result those indexes may
be hard to drop from the driver as they have a name you would not expect.

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * Adam Midvidy
  * aherlihy
  * alexeyvo
  * Christian Hergert
  * Hannes Magnusson
  * Jason Carey
  * Jérôme Lebel
  * Jesse Jiryu Davis
  * lloydzhou
  * Mark Benevenuto
  * Paul Melnikow
  * Samantha Ritter
  * Shraya Ramani
  * Spencer Jackson
  * Tyler Brock


Enjoy!

-- Jason Carey


mongo-c-driver 1.1.0-rc0
========================

It is my pleasure to announce to you the 1.1.0-rc0 release of the MongoDB C driver.

This release is a release candidate with additive ABI changes and bugfixes.

Changes include:
  * ABI versioning for 1.1 versus 1.0 symbols
  * additional geo index options
  * authMechanismProperties in URI
  * fixes for OS X Yosemite
  * removal of replica set member limit
  * SCRAM-SHA-1 SASL mechanism
  * updated dependency on libbson 1.1 abi
  * validation for bulk insert
  * various memory leak fixes

Additions to the ABI include:
  * support for extra option in count
   - mongoc_collection_count_with_opts
  * extra index and collection info
   - mongoc_collection_get_index_info
   - mongoc_database_get_collection_info
  * additional geo options
   - mongoc_index_opt_geo_get_default
   - mongoc_index_opt_geo_init
  * rand interface to seed and verify the strong random number generation needed
    by some auth mechanisms
   - mongoc_rand_seed
   - mongoc_rand_add
   - mongoc_rand_status
  * URI additions to support more complicated auth credentials
   - mongoc_uri_get_credentials
   - mongoc_uri_get_mechanism_properties

Additional Notes:
    Existing complex index names may contain a zero instead of a type due to
a bug in mongoc_collection_keys_to_index_string. As a result those indexes may
be hard to drop from the driver as they have a name you would not expect.

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * Adam Midvidy
  * aherlihy
  * alexeyvo
  * Christian Hergert
  * Jason Carey
  * Jérôme Lebel
  * Samantha Ritter
  * Spencer Jackson
  * Tyler Brock


Enjoy!

-- Jason Carey


mongo-c-driver 1.0.2
====================

It is my pleasure to announce to you the 1.0.2 release of the MongoDB C driver.

This release is a minor point release with no ABI changes and mostly small
bugfixes.

Changes include:
  * A variety of fixes for read preference based node selection
  * Avoided inclusion of getLastError in 2.6 writeConcern
  * Correct handling of pass through params for collection_aggregate
  * Improved error reporting in socket connect
  * Public MONGOC_DEFAULT_CONNECTTIMEOUTMS

Thanks to everyone who contributed to the development of this point release for
libmongoc.

  * Adam Midvidy
  * Christian Hergert
  * Denis Gladkikh
  * Jason Carey
  * Jeremy Mikola
  * Jérôme Lebel
  * Tyler Brock
  * Wisdom Omuya

-- Jason Carey


mongo-c-driver 1.0.0
====================

It is my very distinct pleasure to announce to you the 1.0 release of
the MongoDB C driver!

This is the culmination of just over a year of work and could not have
been done without the help of our wonderful community.

Thanks to everyone who contributed to the development of this driver!

  * Christian Hergert
  * Jason Carey
  * Gary Murakami
  * Christian Heckl
  * Frank Watson Song
  * Hannes Magnusson
  * Jérôme Lebel
  * Kyle Suarez
  * Maga Napanga
  * Michael Kuhn
  * Vincent Giersch
  * essentia44
  * yuqing

Happy Hacking!

-- Christian Hergert


mongo-c-driver 0.98.2
=====================

One final step before our journey to 1.0!

This is a relatively small release, adding some features needed for drivers
building on top of the C driver.

A new libmongoc-priv.so library is installed that does not have symbols
hidden. You can access private headers via the -private.h variants. This
means you will need to recompile your project every time the library is
changed (if you use those private headers, as they are subject to change).

A special thanks to Hannes Magnusson for patches in this release.

See `git shortlog 0.98.0..0.98.2` for a list of all the changes.

-- Christian Hergert


mongo-c-driver 0.98.0
=====================

Another step in the rapidly approaching path to 1.0!

This release is primarily a bugfix release and stablization effort as we
approach 1.0 of the MongoDB C driver.

This release requires 0.98.0 of Libbson for improvements to the memory
management system. You can now setup custom memory allocators at the
start of the process.

This is a RC release that with a few improvements will likely become 1.0.

A special thanks to the following for patches in this cycle:

  * Kyle Suarez
  * yuqing

See `git shortlog 0.96.4..0.98.0` for a list of all the changes.

-- Christian Hergert


mongo-c-driver 0.96.4
=====================

Another incremental feature update and bugfix release!

In this release, you will find the following changes:

  * build/mci.sh script for automatically building Debian packages, RPMs, and
    Solaris packaging based on the host operating system.
  * Various libbson improvements, now depending on 0.8.4.
  * Alignment fixes for Solaris Studio C compiler via libbson.
  * Addition of mongoc_gridfs_remove_by_filename() for removing a file from
    gridfs by filename.
  * client command functions can now take a fully qualified namespace.
  * collections can now support names that indicate a command namespace.
  * Commands will no longer fail if they do not contain an "ok" field.
  * OP_QUERY will now set the slaveOk bit in the wire protocol if
  * readPreferences are set to non-PRIMARY.
  * Various documentation and build fixes.

Thanks again to all the contributors, and happy hacking!


mongo-c-driver 0.96.2
=====================

Hot on the heels of 0.96.0 we would like to present mongo-c-driver 0.96.2!

This is primarily a bugfix release. Included in this release are:

  * Ensure batchSize is used in cursor GETMORE operations with `aggregate`.
  * Ensure enough buffer space is allocated for incoming RPC when buffering
    from a stream.
  * Require libbson 0.8.2 for more robust `bson_next_power_of_two()` when
    using `size_t` and BCON compilation fix with C++.
  * Handle cursor id's that are not 64-bit values in response from
   `aggregate` command.
  * Handle upsert on MongoDB < 2.6 when _id does not contain an `ObjectId`.
  * Use 100 for default batchSize in `aggregate` command.

Happy Hacking!


mongo-c-driver 0.96.0
=====================

It's that time again, time for another mongo-c-driver release!

This release includes much new documentation, which can be found at
https://www.mongodb.com/docs/ecosystem/drivers/c/.

Additionally, this release improves support for various exotic systems.
Solaris 10 is supported much better on SPARC and x86_64 based systems.

Some workarounds for mixed-mode sharded-clusters have been added to improve
resiliency when rolling upgrades are performed.

Build improvements have been added to help us detect SASL and SSL
implementations on platforms that do not support pkg-config. This should
simplify building for some of you.

We've added some more logging to SASL authentication to help debug
authentication failures.

A bug causing an abort() when SSL is used and a server is down has been fixed.

We've renamed various _delete() functions to _remove() to provide consistency
with other MongoDB drivers.

You can now specify SSL options for client pools.

-D_REENTRANT is always defined now on Solaris to help with errno detection.
This may not have been done before if using a non-GCC platform with pthreads.

A bug was fixed where timeouts could have been 1000x longer than expected
due to failure to convert from microseconds to milliseconds.

A bug was fixed with authentication in sharded cluster and replica set
scenarios.

Happy Hacking!


mongo-c-driver 0.94.2
=====================

Hot on the heels of 0.94.0 is 0.94.2, a bugfix release.

A bug has been fixed when using TLS streams and large result sets.

In this release, we added support for Sun's C compiler (Sun Pro C) on Solaris.
This allows for builds on Solaris 10 with SPARC using the native toolchain.

This release contains a couple of fixes in libbson as well.

Keep those bug reports coming, and as always, Happy Hacking!


mongo-c-driver 0.94.0
=====================

The mongo-c-driver team is proud to announce the release of 0.94.0. This
release is a followup to the previous release adding more features to be found
in MongoDB 2.6.

You will find some new API's, bug fixes, and more documentation. Under the
hood, 0.94.0 uses the new write-commands as part of MongoDB 2.6 when it
discovers it is communicating with a MongoDB server. There is now a bulk
operation API (See `mongoc-bulk-operation.h`).

Helpers for common server commands have been added. You can find most of
them `mongoc-collection.h`.

To simply using mongo-c-driver from Windows, we've included pre-built binaries
on the release page.

Thanks to all of the contributors this release!

Happy Hacking!


mongo-c-driver 0.92.0
=====================

The mongo-c-driver team is proud to announce the release of 0.92.0. This
release is the culimation of a few months work and has many bug fixes and
new features. It contains over 350 commits from 4 authors since the 0.90.0
release.

The mongo-c-driver release tarballs now contain a bundled copy of libbson.
If you do not have libbson installed or the system installed libbson is too
old, the bundled copy of libbson will be installed.

  * Revamped build system to simplify installation.
  * Windows Vista and newer support.
  * Various GridFS fixes and features.
  * Kerberos support via cyrus-sasl.
  * Various SSL improvements.
  * Support for Solaris 11, FreeBSD 10, RHEL 5+, and SmartOS.
  * A new client side expression matcher to perform basic query processing.
    It can perform queries such as {'field': {'$in': [1,2,3]}}. See
    mongoc_matcher_t for more information.
  * A new socket abstraction for platform independent network sockets.
  * A new mongoc-dump example for how to write a simple mongodump replacement.
  * Counters can use rdtscp instruction on Core iX systems for very fast
    counters.
  * configure has new options. If in doubt, the defaults are sensible.
   * --enable-coverage=yes|no
   * --enable-debug=yes|no
   * --enable-debug-symbols=yes|no
   * --enable-hardening=yes|no
   * --enable-optimizations=yes|no
   * --enable-ssl=yes|no
   * --enable-sasl=yes|no
   * --enable-tracing=yes|no
   * --with-libbson=auto|system|bundled

mongo-c-driver 0.92.0 requires libbson 0.6.4 or newer.

Happy Hacking!


Libmongoc 0.90.0
================

This is the initial release of the new Libmongoc. We chose 0.90.0 for the
release version to differentiate ourselves from the, now legacy, version of
libmongoc. We will rapidly work towards reaching an API/ABI stable library fit
for a 1.0.0 release.

Libmongoc is Apache licensed so it can be embedded in a multitude of scenarios.

The API of 0.90.0 is completely different from the previous versions. We think
this allowed us to create a high-quality library that you will enjoy using in
your applications.

Many outstanding bugs were closed in the process of creating Libbson 0.90.0. So
if you had a pet issue, please take a look to see if it was resolved as part of
this effort!

Thanks, and enjoy developing your applications with libmongoc!
